<?php

namespace PHPMaker2021\educlaims;

use Slim\App;
use Slim\Routing\RouteCollectorProxy;

// Handle Routes
return function (App $app) {
    // claims
    $app->any('/claimslist[/{id}]', ClaimsController::class . ':list')->add(PermissionMiddleware::class)->setName('claimslist-claims-list'); // list
    $app->any('/claimsadd[/{id}]', ClaimsController::class . ':add')->add(PermissionMiddleware::class)->setName('claimsadd-claims-add'); // add
    $app->any('/claimsview[/{id}]', ClaimsController::class . ':view')->add(PermissionMiddleware::class)->setName('claimsview-claims-view'); // view
    $app->any('/claimsedit[/{id}]', ClaimsController::class . ':edit')->add(PermissionMiddleware::class)->setName('claimsedit-claims-edit'); // edit
    $app->any('/claimsdelete[/{id}]', ClaimsController::class . ':delete')->add(PermissionMiddleware::class)->setName('claimsdelete-claims-delete'); // delete
    $app->group(
        '/claims',
        function (RouteCollectorProxy $group) {
            $group->any('/' . Config("LIST_ACTION") . '[/{id}]', ClaimsController::class . ':list')->add(PermissionMiddleware::class)->setName('claims/list-claims-list-2'); // list
            $group->any('/' . Config("ADD_ACTION") . '[/{id}]', ClaimsController::class . ':add')->add(PermissionMiddleware::class)->setName('claims/add-claims-add-2'); // add
            $group->any('/' . Config("VIEW_ACTION") . '[/{id}]', ClaimsController::class . ':view')->add(PermissionMiddleware::class)->setName('claims/view-claims-view-2'); // view
            $group->any('/' . Config("EDIT_ACTION") . '[/{id}]', ClaimsController::class . ':edit')->add(PermissionMiddleware::class)->setName('claims/edit-claims-edit-2'); // edit
            $group->any('/' . Config("DELETE_ACTION") . '[/{id}]', ClaimsController::class . ':delete')->add(PermissionMiddleware::class)->setName('claims/delete-claims-delete-2'); // delete
        }
    );

    // audit
    $app->any('/auditlist[/{id}]', AuditController::class . ':list')->add(PermissionMiddleware::class)->setName('auditlist-audit-list'); // list
    $app->any('/auditadd[/{id}]', AuditController::class . ':add')->add(PermissionMiddleware::class)->setName('auditadd-audit-add'); // add
    $app->any('/auditview[/{id}]', AuditController::class . ':view')->add(PermissionMiddleware::class)->setName('auditview-audit-view'); // view
    $app->any('/auditedit[/{id}]', AuditController::class . ':edit')->add(PermissionMiddleware::class)->setName('auditedit-audit-edit'); // edit
    $app->any('/auditdelete[/{id}]', AuditController::class . ':delete')->add(PermissionMiddleware::class)->setName('auditdelete-audit-delete'); // delete
    $app->group(
        '/audit',
        function (RouteCollectorProxy $group) {
            $group->any('/' . Config("LIST_ACTION") . '[/{id}]', AuditController::class . ':list')->add(PermissionMiddleware::class)->setName('audit/list-audit-list-2'); // list
            $group->any('/' . Config("ADD_ACTION") . '[/{id}]', AuditController::class . ':add')->add(PermissionMiddleware::class)->setName('audit/add-audit-add-2'); // add
            $group->any('/' . Config("VIEW_ACTION") . '[/{id}]', AuditController::class . ':view')->add(PermissionMiddleware::class)->setName('audit/view-audit-view-2'); // view
            $group->any('/' . Config("EDIT_ACTION") . '[/{id}]', AuditController::class . ':edit')->add(PermissionMiddleware::class)->setName('audit/edit-audit-edit-2'); // edit
            $group->any('/' . Config("DELETE_ACTION") . '[/{id}]', AuditController::class . ':delete')->add(PermissionMiddleware::class)->setName('audit/delete-audit-delete-2'); // delete
        }
    );

    // user
    $app->any('/userlist[/{id}]', UserController::class . ':list')->add(PermissionMiddleware::class)->setName('userlist-user-list'); // list
    $app->any('/useradd[/{id}]', UserController::class . ':add')->add(PermissionMiddleware::class)->setName('useradd-user-add'); // add
    $app->any('/userview[/{id}]', UserController::class . ':view')->add(PermissionMiddleware::class)->setName('userview-user-view'); // view
    $app->any('/useredit[/{id}]', UserController::class . ':edit')->add(PermissionMiddleware::class)->setName('useredit-user-edit'); // edit
    $app->any('/userdelete[/{id}]', UserController::class . ':delete')->add(PermissionMiddleware::class)->setName('userdelete-user-delete'); // delete
    $app->group(
        '/user',
        function (RouteCollectorProxy $group) {
            $group->any('/' . Config("LIST_ACTION") . '[/{id}]', UserController::class . ':list')->add(PermissionMiddleware::class)->setName('user/list-user-list-2'); // list
            $group->any('/' . Config("ADD_ACTION") . '[/{id}]', UserController::class . ':add')->add(PermissionMiddleware::class)->setName('user/add-user-add-2'); // add
            $group->any('/' . Config("VIEW_ACTION") . '[/{id}]', UserController::class . ':view')->add(PermissionMiddleware::class)->setName('user/view-user-view-2'); // view
            $group->any('/' . Config("EDIT_ACTION") . '[/{id}]', UserController::class . ':edit')->add(PermissionMiddleware::class)->setName('user/edit-user-edit-2'); // edit
            $group->any('/' . Config("DELETE_ACTION") . '[/{id}]', UserController::class . ':delete')->add(PermissionMiddleware::class)->setName('user/delete-user-delete-2'); // delete
        }
    );

    // welcome
    $app->any('/welcome[/{params:.*}]', WelcomeController::class)->add(PermissionMiddleware::class)->setName('welcome-welcome-custom'); // custom

    // userattrs
    $app->any('/userattrslist[/{id}]', UserattrsController::class . ':list')->add(PermissionMiddleware::class)->setName('userattrslist-userattrs-list'); // list
    $app->any('/userattrsadd[/{id}]', UserattrsController::class . ':add')->add(PermissionMiddleware::class)->setName('userattrsadd-userattrs-add'); // add
    $app->any('/userattrsview[/{id}]', UserattrsController::class . ':view')->add(PermissionMiddleware::class)->setName('userattrsview-userattrs-view'); // view
    $app->any('/userattrsedit[/{id}]', UserattrsController::class . ':edit')->add(PermissionMiddleware::class)->setName('userattrsedit-userattrs-edit'); // edit
    $app->any('/userattrsdelete[/{id}]', UserattrsController::class . ':delete')->add(PermissionMiddleware::class)->setName('userattrsdelete-userattrs-delete'); // delete
    $app->group(
        '/userattrs',
        function (RouteCollectorProxy $group) {
            $group->any('/' . Config("LIST_ACTION") . '[/{id}]', UserattrsController::class . ':list')->add(PermissionMiddleware::class)->setName('userattrs/list-userattrs-list-2'); // list
            $group->any('/' . Config("ADD_ACTION") . '[/{id}]', UserattrsController::class . ':add')->add(PermissionMiddleware::class)->setName('userattrs/add-userattrs-add-2'); // add
            $group->any('/' . Config("VIEW_ACTION") . '[/{id}]', UserattrsController::class . ':view')->add(PermissionMiddleware::class)->setName('userattrs/view-userattrs-view-2'); // view
            $group->any('/' . Config("EDIT_ACTION") . '[/{id}]', UserattrsController::class . ':edit')->add(PermissionMiddleware::class)->setName('userattrs/edit-userattrs-edit-2'); // edit
            $group->any('/' . Config("DELETE_ACTION") . '[/{id}]', UserattrsController::class . ':delete')->add(PermissionMiddleware::class)->setName('userattrs/delete-userattrs-delete-2'); // delete
        }
    );

    // clm_categories
    $app->any('/clmcategorieslist', ClmCategoriesController::class . ':list')->add(PermissionMiddleware::class)->setName('clmcategorieslist-clm_categories-list'); // list
    $app->group(
        '/clm_categories',
        function (RouteCollectorProxy $group) {
            $group->any('/' . Config("LIST_ACTION") . '', ClmCategoriesController::class . ':list')->add(PermissionMiddleware::class)->setName('clm_categories/list-clm_categories-list-2'); // list
        }
    );

    // v_usr
    $app->any('/vusrlist[/{id}]', VUsrController::class . ':list')->add(PermissionMiddleware::class)->setName('vusrlist-v_usr-list'); // list
    $app->group(
        '/v_usr',
        function (RouteCollectorProxy $group) {
            $group->any('/' . Config("LIST_ACTION") . '[/{id}]', VUsrController::class . ':list')->add(PermissionMiddleware::class)->setName('v_usr/list-v_usr-list-2'); // list
        }
    );

    // v_clm
    $app->any('/vclmlist[/{id}]', VClmController::class . ':list')->add(PermissionMiddleware::class)->setName('vclmlist-v_clm-list'); // list
    $app->group(
        '/v_clm',
        function (RouteCollectorProxy $group) {
            $group->any('/' . Config("LIST_ACTION") . '[/{id}]', VClmController::class . ':list')->add(PermissionMiddleware::class)->setName('v_clm/list-v_clm-list-2'); // list
        }
    );

    // signature
    $app->any('/signaturelist[/{id}]', SignatureController::class . ':list')->add(PermissionMiddleware::class)->setName('signaturelist-signature-list'); // list
    $app->group(
        '/signature',
        function (RouteCollectorProxy $group) {
            $group->any('/' . Config("LIST_ACTION") . '[/{id}]', SignatureController::class . ':list')->add(PermissionMiddleware::class)->setName('signature/list-signature-list-2'); // list
        }
    );

    // signpage
    $app->any('/signpage[/{params:.*}]', SignpageController::class)->add(PermissionMiddleware::class)->setName('signpage-signpage-custom'); // custom

    // tosign
    $app->any('/tosign[/{params:.*}]', TosignController::class)->add(PermissionMiddleware::class)->setName('tosign-tosign-custom'); // custom

    // yourclaims
    $app->any('/yourclaims[/{params:.*}]', YourclaimsController::class)->add(PermissionMiddleware::class)->setName('yourclaims-yourclaims-custom'); // custom

    // error
    $app->any('/error', OthersController::class . ':error')->add(PermissionMiddleware::class)->setName('error');

    // personal_data
    $app->any('/personaldata', OthersController::class . ':personaldata')->add(PermissionMiddleware::class)->setName('personaldata');

    // login
    $app->any('/login', OthersController::class . ':login')->add(PermissionMiddleware::class)->setName('login');

    // logout
    $app->any('/logout', OthersController::class . ':logout')->add(PermissionMiddleware::class)->setName('logout');

    // Swagger
    $app->get('/' . Config("SWAGGER_ACTION"), OthersController::class . ':swagger')->setName(Config("SWAGGER_ACTION")); // Swagger

    // Index
    $app->any('/[index]', OthersController::class . ':index')->add(PermissionMiddleware::class)->setName('index');

    // Route Action event
    if (function_exists(PROJECT_NAMESPACE . "Route_Action")) {
        Route_Action($app);
    }

    /**
     * Catch-all route to serve a 404 Not Found page if none of the routes match
     * NOTE: Make sure this route is defined last.
     */
    $app->map(
        ['GET', 'POST', 'PUT', 'DELETE', 'PATCH'],
        '/{routes:.+}',
        function ($request, $response, $params) {
            $error = [
                "statusCode" => "404",
                "error" => [
                    "class" => "text-warning",
                    "type" => Container("language")->phrase("Error"),
                    "description" => str_replace("%p", $params["routes"], Container("language")->phrase("PageNotFound")),
                ],
            ];
            Container("flash")->addMessage("error", $error);
            return $response->withStatus(302)->withHeader("Location", GetUrl("error")); // Redirect to error page
        }
    );
};
