<?php

namespace PHPMaker2021\educlaims;

use Psr\Http\Message\ServerRequestInterface as Request;
use Psr\Http\Message\ResponseInterface as Response;
use Psr\Container\ContainerInterface;

// Filter for 'Last Month' (example)
function GetLastMonthFilter($FldExpression, $dbid = 0)
{
    $today = getdate();
    $lastmonth = mktime(0, 0, 0, $today['mon'] - 1, 1, $today['year']);
    $val = date("Y|m", $lastmonth);
    $wrk = $FldExpression . " BETWEEN " .
        QuotedValue(DateValue("month", $val, 1, $dbid), DATATYPE_DATE, $dbid) .
        " AND " .
        QuotedValue(DateValue("month", $val, 2, $dbid), DATATYPE_DATE, $dbid);
    return $wrk;
}

// Filter for 'Starts With A' (example)
function GetStartsWithAFilter($FldExpression, $dbid = 0)
{
    return $FldExpression . Like("'A%'", $dbid);
}

// Global user functions

// Database Connecting event
function Database_Connecting(&$info)
{
    // Example:
    //var_dump($info);
    //if ($info["id"] == "DB" && IsLocal()) { // Testing on local PC
    //    $info["host"] = "locahost";
    //    $info["user"] = "root";
    //    $info["pass"] = "";
    //}
}

// Database Connected event
function Database_Connected(&$conn)
{
    // Example:
    //if ($conn->info["id"] == "DB") {
    //    $conn->executeQuery("Your SQL");
    //}
}

function MenuItem_Adding($item)
{
    //var_dump($item);
    // Return false if menu item not allowed
    return true;
}

function Menu_Rendering($menu)
{
    // Change menu items here
}

function Menu_Rendered($menu)
{
    // Clean up here
}

// Page Loading event
function Page_Loading()
{
    //Log("Page Loading");
}

// Page Rendering event
function Page_Rendering()
{
    //Log("Page Rendering");
}

// Page Unloaded event
function Page_Unloaded()
{
    //Log("Page Unloaded");
}

// AuditTrail Inserting event
function AuditTrail_Inserting(&$rsnew)
{
    //var_dump($rsnew);
    return true;
}

// Personal Data Downloading event
function PersonalData_Downloading(&$row)
{
    //Log("PersonalData Downloading");
}

// Personal Data Deleted event
function PersonalData_Deleted($row)
{
    //Log("PersonalData Deleted");
}

// Route Action event
function Route_Action($app)
{
    // Example:
    // $app->get('/myaction', function ($request, $response, $args) {
    //    return $response->withJson(["name" => "myaction"]); // Note: Always return Psr\Http\Message\ResponseInterface object
    // });
    // $app->get('/myaction2', function ($request, $response, $args) {
    //    return $response->withJson(["name" => "myaction2"]); // Note: Always return Psr\Http\Message\ResponseInterface object
    // });
}

// API Action event
function Api_Action($app)
{
    // Example:
    // $app->get('/myaction', function ($request, $response, $args) {
    //    return $response->withJson(["name" => "myaction"]); // Note: Always return Psr\Http\Message\ResponseInterface object
    // });
    // $app->get('/myaction2', function ($request, $response, $args) {
    //    return $response->withJson(["name" => "myaction2"]); // Note: Always return Psr\Http\Message\ResponseInterface object
    // });
}

// Container Build event
function Container_Build($builder)
{
    // Example:
    // $builder->addDefinitions([
    //    "myservice" => function (ContainerInterface $c) {
    //        // your code to provide the service, e.g.
    //        return new MyService();
    //    },
    //    "myservice2" => function (ContainerInterface $c) {
    //        // your code to provide the service, e.g.
    //        return new MyService2();
    //    }
    // ]);
}

function get_display_string($uname) {
	return ExecuteScalar("SELECT displayString FROM user WHERE username = '" . $uname . "'");
}

function display_claim_status($claim_id) {
	$signers_string = ExecuteScalar("SELECT signers FROM claims WHERE id = ".$claim_id);
	$signers = explode(',',$signers_string);
	$all_signed = false;
	$c_signers = count($signers);
	$c_signatures = 0;
	foreach ($signers as $signer) {
		echo get_display_string($signer);
		$c = ExecuteScalar("SELECT COUNT(*) FROM signature WHERE claim_id = " . $claim_id . " AND uname ='" . $signer . "'");
		echo " ";
		if ($c > 0) {
			echo "SIGNED";
			$c_signatures++;		
		} else {
			echo "NOT Signed";
		}
		echo "<br/>";
	}
	echo "Signatures: $c_signatures / $c_signers";
	if ($c_signatures != $c_signers) {
		return false;
	} else {
		return true;
	}
}

function get_tosign () {
	$uname = CurrentUserName();
	$tosign = ExecuteRows("SELECT claims.id AS claim_id, claims.title AS title, v_usr.displayString AS disp FROM claims INNER JOIN v_usr ON claims.subject = v_usr.id  WHERE signers LIKE '%" . $uname . "%'");
	$signed = ExecuteRows("SELECT claim_id FROM signature WHERE uname = '" . $uname . "'");
	$toremove = array();
	foreach($signed as $sgn) {
		array_push($toremove,$sgn['claim_id']);
	}
	$toremove_ids = array();
	foreach($tosign as $ind => $claim) {
		if(in_array($claim["claim_id"],$toremove)) {
			array_push($toremove_ids,$ind);
		}
	}
	foreach($toremove_ids as $rid) {
		unset($tosign[$rid]);
	}
	return $tosign;
}

function get_signed () {
	$uname = CurrentUserName();
	$ret = ExecuteRows("SELECT claims.created_at AS created, claims.filename AS file, claims.id AS claim_id, claims.title AS title, v_usr.displayString AS disp FROM claims INNER JOIN v_usr ON claims.subject = v_usr.id  WHERE signers LIKE '%" . $uname . "%'");
	$signed = ExecuteRows("SELECT claim_id FROM signature WHERE uname = '" . $uname . "'");
	$toremove = array();
	foreach($signed as $sgn) {
		array_push($toremove,$sgn['claim_id']);
	}
	$toremove_ids = array();
	foreach($ret as $ind => $claim) {
		if(!in_array($claim["claim_id"],$toremove)) {
			array_push($toremove_ids,$ind);
		}
	}
	foreach($toremove_ids as $rid) {
		unset($ret[$rid]);
	}
	return $ret;
}

function get_aboutyou () {
	$uid = CurrentUserID();
	$aboutyou = ExecuteRows("SELECT claims.created_at AS created, claims.filename AS file, claims.id AS id, claims.title AS title FROM claims WHERE subject =" . $uid . "");
	return $aboutyou;
}

function count_tosign() {
	return count(get_tosign());
}
