<?php

namespace PHPMaker2021\educlaims;

// Set up and run Grid object
$Grid = Container("ClaimSignerGrid");
$Grid->run();
?>
<?php if (!$Grid->isExport()) { ?>
<script>
var currentForm, currentPageID;
var fclaim_signergrid;
loadjs.ready("head", function () {
    var $ = jQuery;
    // Form object
    fclaim_signergrid = new ew.Form("fclaim_signergrid", "grid");
    fclaim_signergrid.formKeyCountName = '<?= $Grid->FormKeyCountName ?>';

    // Add fields
    var currentTable = <?= JsonEncode(GetClientVar("tables", "claim_signer")) ?>,
        fields = currentTable.fields;
    if (!ew.vars.tables.claim_signer)
        ew.vars.tables.claim_signer = currentTable;
    fclaim_signergrid.addFields([
        ["claim_id", [fields.claim_id.visible && fields.claim_id.required ? ew.Validators.required(fields.claim_id.caption) : null, ew.Validators.integer], fields.claim_id.isInvalid],
        ["user_id", [fields.user_id.visible && fields.user_id.required ? ew.Validators.required(fields.user_id.caption) : null], fields.user_id.isInvalid],
        ["signed", [fields.signed.visible && fields.signed.required ? ew.Validators.required(fields.signed.caption) : null], fields.signed.isInvalid]
    ]);

    // Set invalid fields
    $(function() {
        var f = fclaim_signergrid,
            fobj = f.getForm(),
            $fobj = $(fobj),
            $k = $fobj.find("#" + f.formKeyCountName), // Get key_count
            rowcnt = ($k[0]) ? parseInt($k.val(), 10) : 1,
            startcnt = (rowcnt == 0) ? 0 : 1; // Check rowcnt == 0 => Inline-Add
        for (var i = startcnt; i <= rowcnt; i++) {
            var rowIndex = ($k[0]) ? String(i) : "";
            f.setInvalid(rowIndex);
        }
    });

    // Validate form
    fclaim_signergrid.validate = function () {
        if (!this.validateRequired)
            return true; // Ignore validation
        var fobj = this.getForm(),
            $fobj = $(fobj);
        if ($fobj.find("#confirm").val() == "confirm")
            return true;
        var addcnt = 0,
            $k = $fobj.find("#" + this.formKeyCountName), // Get key_count
            rowcnt = ($k[0]) ? parseInt($k.val(), 10) : 1,
            startcnt = (rowcnt == 0) ? 0 : 1, // Check rowcnt == 0 => Inline-Add
            gridinsert = ["insert", "gridinsert"].includes($fobj.find("#action").val()) && $k[0];
        for (var i = startcnt; i <= rowcnt; i++) {
            var rowIndex = ($k[0]) ? String(i) : "";
            $fobj.data("rowindex", rowIndex);
            var checkrow = (gridinsert) ? !this.emptyRow(rowIndex) : true;
            if (checkrow) {
                addcnt++;

            // Validate fields
            if (!this.validateFields(rowIndex))
                return false;

            // Call Form_CustomValidate event
            if (!this.customValidate(fobj)) {
                this.focus();
                return false;
            }
            } // End Grid Add checking
        }
        return true;
    }

    // Check empty row
    fclaim_signergrid.emptyRow = function (rowIndex) {
        var fobj = this.getForm();
        if (ew.valueChanged(fobj, rowIndex, "claim_id", false))
            return false;
        if (ew.valueChanged(fobj, rowIndex, "user_id", false))
            return false;
        if (ew.valueChanged(fobj, rowIndex, "signed", true))
            return false;
        return true;
    }

    // Form_CustomValidate
    fclaim_signergrid.customValidate = function(fobj) { // DO NOT CHANGE THIS LINE!
        // Your custom validation code here, return false if invalid.
        return true;
    }

    // Use JavaScript validation or not
    fclaim_signergrid.validateRequired = <?= Config("CLIENT_VALIDATE") ? "true" : "false" ?>;

    // Dynamic selection lists
    fclaim_signergrid.lists.user_id = <?= $Grid->user_id->toClientList($Grid) ?>;
    fclaim_signergrid.lists.signed = <?= $Grid->signed->toClientList($Grid) ?>;
    loadjs.done("fclaim_signergrid");
});
</script>
<?php } ?>
<?php
$Grid->renderOtherOptions();
?>
<?php if ($Grid->TotalRecords > 0 || $Grid->CurrentAction) { ?>
<div class="card ew-card ew-grid<?php if ($Grid->isAddOrEdit()) { ?> ew-grid-add-edit<?php } ?> claim_signer">
<div id="fclaim_signergrid" class="ew-form ew-list-form form-inline">
<div id="gmp_claim_signer" class="<?= ResponsiveTableClass() ?>card-body ew-grid-middle-panel">
<table id="tbl_claim_signergrid" class="table ew-table"><!-- .ew-table -->
<thead>
    <tr class="ew-table-header">
<?php
// Header row
$Grid->RowType = ROWTYPE_HEADER;

// Render list options
$Grid->renderListOptions();

// Render list options (header, left)
$Grid->ListOptions->render("header", "left");
?>
<?php if ($Grid->claim_id->Visible) { // claim_id ?>
        <th data-name="claim_id" class="<?= $Grid->claim_id->headerCellClass() ?>"><div id="elh_claim_signer_claim_id" class="claim_signer_claim_id"><?= $Grid->renderSort($Grid->claim_id) ?></div></th>
<?php } ?>
<?php if ($Grid->user_id->Visible) { // user_id ?>
        <th data-name="user_id" class="<?= $Grid->user_id->headerCellClass() ?>"><div id="elh_claim_signer_user_id" class="claim_signer_user_id"><?= $Grid->renderSort($Grid->user_id) ?></div></th>
<?php } ?>
<?php if ($Grid->signed->Visible) { // signed ?>
        <th data-name="signed" class="<?= $Grid->signed->headerCellClass() ?>"><div id="elh_claim_signer_signed" class="claim_signer_signed"><?= $Grid->renderSort($Grid->signed) ?></div></th>
<?php } ?>
<?php
// Render list options (header, right)
$Grid->ListOptions->render("header", "right");
?>
    </tr>
</thead>
<tbody>
<?php
$Grid->StartRecord = 1;
$Grid->StopRecord = $Grid->TotalRecords; // Show all records

// Restore number of post back records
if ($CurrentForm && ($Grid->isConfirm() || $Grid->EventCancelled)) {
    $CurrentForm->Index = -1;
    if ($CurrentForm->hasValue($Grid->FormKeyCountName) && ($Grid->isGridAdd() || $Grid->isGridEdit() || $Grid->isConfirm())) {
        $Grid->KeyCount = $CurrentForm->getValue($Grid->FormKeyCountName);
        $Grid->StopRecord = $Grid->StartRecord + $Grid->KeyCount - 1;
    }
}
$Grid->RecordCount = $Grid->StartRecord - 1;
if ($Grid->Recordset && !$Grid->Recordset->EOF) {
    // Nothing to do
} elseif (!$Grid->AllowAddDeleteRow && $Grid->StopRecord == 0) {
    $Grid->StopRecord = $Grid->GridAddRowCount;
}

// Initialize aggregate
$Grid->RowType = ROWTYPE_AGGREGATEINIT;
$Grid->resetAttributes();
$Grid->renderRow();
if ($Grid->isGridAdd())
    $Grid->RowIndex = 0;
if ($Grid->isGridEdit())
    $Grid->RowIndex = 0;
while ($Grid->RecordCount < $Grid->StopRecord) {
    $Grid->RecordCount++;
    if ($Grid->RecordCount >= $Grid->StartRecord) {
        $Grid->RowCount++;
        if ($Grid->isGridAdd() || $Grid->isGridEdit() || $Grid->isConfirm()) {
            $Grid->RowIndex++;
            $CurrentForm->Index = $Grid->RowIndex;
            if ($CurrentForm->hasValue($Grid->FormActionName) && ($Grid->isConfirm() || $Grid->EventCancelled)) {
                $Grid->RowAction = strval($CurrentForm->getValue($Grid->FormActionName));
            } elseif ($Grid->isGridAdd()) {
                $Grid->RowAction = "insert";
            } else {
                $Grid->RowAction = "";
            }
        }

        // Set up key count
        $Grid->KeyCount = $Grid->RowIndex;

        // Init row class and style
        $Grid->resetAttributes();
        $Grid->CssClass = "";
        if ($Grid->isGridAdd()) {
            if ($Grid->CurrentMode == "copy") {
                $Grid->loadRowValues($Grid->Recordset); // Load row values
                $Grid->OldKey = $Grid->getKey(true); // Get from CurrentValue
            } else {
                $Grid->loadRowValues(); // Load default values
                $Grid->OldKey = "";
            }
        } else {
            $Grid->loadRowValues($Grid->Recordset); // Load row values
            $Grid->OldKey = $Grid->getKey(true); // Get from CurrentValue
        }
        $Grid->setKey($Grid->OldKey);
        $Grid->RowType = ROWTYPE_VIEW; // Render view
        if ($Grid->isGridAdd()) { // Grid add
            $Grid->RowType = ROWTYPE_ADD; // Render add
        }
        if ($Grid->isGridAdd() && $Grid->EventCancelled && !$CurrentForm->hasValue("k_blankrow")) { // Insert failed
            $Grid->restoreCurrentRowFormValues($Grid->RowIndex); // Restore form values
        }
        if ($Grid->isGridEdit()) { // Grid edit
            if ($Grid->EventCancelled) {
                $Grid->restoreCurrentRowFormValues($Grid->RowIndex); // Restore form values
            }
            if ($Grid->RowAction == "insert") {
                $Grid->RowType = ROWTYPE_ADD; // Render add
            } else {
                $Grid->RowType = ROWTYPE_EDIT; // Render edit
            }
        }
        if ($Grid->isGridEdit() && ($Grid->RowType == ROWTYPE_EDIT || $Grid->RowType == ROWTYPE_ADD) && $Grid->EventCancelled) { // Update failed
            $Grid->restoreCurrentRowFormValues($Grid->RowIndex); // Restore form values
        }
        if ($Grid->RowType == ROWTYPE_EDIT) { // Edit row
            $Grid->EditRowCount++;
        }
        if ($Grid->isConfirm()) { // Confirm row
            $Grid->restoreCurrentRowFormValues($Grid->RowIndex); // Restore form values
        }

        // Set up row id / data-rowindex
        $Grid->RowAttrs->merge(["data-rowindex" => $Grid->RowCount, "id" => "r" . $Grid->RowCount . "_claim_signer", "data-rowtype" => $Grid->RowType]);

        // Render row
        $Grid->renderRow();

        // Render list options
        $Grid->renderListOptions();

        // Skip delete row / empty row for confirm page
        if ($Grid->RowAction != "delete" && $Grid->RowAction != "insertdelete" && !($Grid->RowAction == "insert" && $Grid->isConfirm() && $Grid->emptyRow())) {
?>
    <tr <?= $Grid->rowAttributes() ?>>
<?php
// Render list options (body, left)
$Grid->ListOptions->render("body", "left", $Grid->RowCount);
?>
    <?php if ($Grid->claim_id->Visible) { // claim_id ?>
        <td data-name="claim_id" <?= $Grid->claim_id->cellAttributes() ?>>
<?php if ($Grid->RowType == ROWTYPE_ADD) { // Add record ?>
<?php if ($Grid->claim_id->getSessionValue() != "") { ?>
<span id="el<?= $Grid->RowCount ?>_claim_signer_claim_id" class="form-group">
<span<?= $Grid->claim_id->viewAttributes() ?>>
<input type="text" readonly class="form-control-plaintext" value="<?= HtmlEncode(RemoveHtml($Grid->claim_id->getDisplayValue($Grid->claim_id->ViewValue))) ?>"></span>
</span>
<input type="hidden" id="x<?= $Grid->RowIndex ?>_claim_id" name="x<?= $Grid->RowIndex ?>_claim_id" value="<?= HtmlEncode($Grid->claim_id->CurrentValue) ?>" data-hidden="1">
<?php } else { ?>
<span id="el<?= $Grid->RowCount ?>_claim_signer_claim_id" class="form-group">
<input type="<?= $Grid->claim_id->getInputTextType() ?>" data-table="claim_signer" data-field="x_claim_id" name="x<?= $Grid->RowIndex ?>_claim_id" id="x<?= $Grid->RowIndex ?>_claim_id" size="30" maxlength="11" placeholder="<?= HtmlEncode($Grid->claim_id->getPlaceHolder()) ?>" value="<?= $Grid->claim_id->EditValue ?>"<?= $Grid->claim_id->editAttributes() ?>>
<div class="invalid-feedback"><?= $Grid->claim_id->getErrorMessage() ?></div>
</span>
<?php } ?>
<input type="hidden" data-table="claim_signer" data-field="x_claim_id" data-hidden="1" name="o<?= $Grid->RowIndex ?>_claim_id" id="o<?= $Grid->RowIndex ?>_claim_id" value="<?= HtmlEncode($Grid->claim_id->OldValue) ?>">
<?php } ?>
<?php if ($Grid->RowType == ROWTYPE_EDIT) { // Edit record ?>
<?php if ($Grid->claim_id->getSessionValue() != "") { ?>
<span id="el<?= $Grid->RowCount ?>_claim_signer_claim_id" class="form-group">
<span<?= $Grid->claim_id->viewAttributes() ?>>
<input type="text" readonly class="form-control-plaintext" value="<?= HtmlEncode(RemoveHtml($Grid->claim_id->getDisplayValue($Grid->claim_id->ViewValue))) ?>"></span>
</span>
<input type="hidden" id="x<?= $Grid->RowIndex ?>_claim_id" name="x<?= $Grid->RowIndex ?>_claim_id" value="<?= HtmlEncode($Grid->claim_id->CurrentValue) ?>" data-hidden="1">
<?php } else { ?>
<span id="el<?= $Grid->RowCount ?>_claim_signer_claim_id" class="form-group">
<input type="<?= $Grid->claim_id->getInputTextType() ?>" data-table="claim_signer" data-field="x_claim_id" name="x<?= $Grid->RowIndex ?>_claim_id" id="x<?= $Grid->RowIndex ?>_claim_id" size="30" maxlength="11" placeholder="<?= HtmlEncode($Grid->claim_id->getPlaceHolder()) ?>" value="<?= $Grid->claim_id->EditValue ?>"<?= $Grid->claim_id->editAttributes() ?>>
<div class="invalid-feedback"><?= $Grid->claim_id->getErrorMessage() ?></div>
</span>
<?php } ?>
<?php } ?>
<?php if ($Grid->RowType == ROWTYPE_VIEW) { // View record ?>
<span id="el<?= $Grid->RowCount ?>_claim_signer_claim_id">
<span<?= $Grid->claim_id->viewAttributes() ?>>
<?= $Grid->claim_id->getViewValue() ?></span>
</span>
<?php if ($Grid->isConfirm()) { ?>
<input type="hidden" data-table="claim_signer" data-field="x_claim_id" data-hidden="1" name="fclaim_signergrid$x<?= $Grid->RowIndex ?>_claim_id" id="fclaim_signergrid$x<?= $Grid->RowIndex ?>_claim_id" value="<?= HtmlEncode($Grid->claim_id->FormValue) ?>">
<input type="hidden" data-table="claim_signer" data-field="x_claim_id" data-hidden="1" name="fclaim_signergrid$o<?= $Grid->RowIndex ?>_claim_id" id="fclaim_signergrid$o<?= $Grid->RowIndex ?>_claim_id" value="<?= HtmlEncode($Grid->claim_id->OldValue) ?>">
<?php } ?>
<?php } ?>
</td>
    <?php } ?>
    <?php if ($Grid->user_id->Visible) { // user_id ?>
        <td data-name="user_id" <?= $Grid->user_id->cellAttributes() ?>>
<?php if ($Grid->RowType == ROWTYPE_ADD) { // Add record ?>
<?php if (!$Security->isAdmin() && $Security->isLoggedIn() && !$Grid->userIDAllow("grid")) { // Non system admin ?>
<span id="el<?= $Grid->RowCount ?>_claim_signer_user_id" class="form-group">
<span<?= $Grid->user_id->viewAttributes() ?>>
<input type="text" readonly class="form-control-plaintext" value="<?= HtmlEncode(RemoveHtml($Grid->user_id->getDisplayValue($Grid->user_id->EditValue))) ?>"></span>
</span>
<input type="hidden" data-table="claim_signer" data-field="x_user_id" data-hidden="1" name="x<?= $Grid->RowIndex ?>_user_id" id="x<?= $Grid->RowIndex ?>_user_id" value="<?= HtmlEncode($Grid->user_id->CurrentValue) ?>">
<?php } else { ?>
<span id="el<?= $Grid->RowCount ?>_claim_signer_user_id" class="form-group">
    <select
        id="x<?= $Grid->RowIndex ?>_user_id"
        name="x<?= $Grid->RowIndex ?>_user_id"
        class="form-control ew-select<?= $Grid->user_id->isInvalidClass() ?>"
        data-select2-id="claim_signer_x<?= $Grid->RowIndex ?>_user_id"
        data-table="claim_signer"
        data-field="x_user_id"
        data-value-separator="<?= $Grid->user_id->displayValueSeparatorAttribute() ?>"
        data-placeholder="<?= HtmlEncode($Grid->user_id->getPlaceHolder()) ?>"
        <?= $Grid->user_id->editAttributes() ?>>
        <?= $Grid->user_id->selectOptionListHtml("x{$Grid->RowIndex}_user_id") ?>
    </select>
    <div class="invalid-feedback"><?= $Grid->user_id->getErrorMessage() ?></div>
<?= $Grid->user_id->Lookup->getParamTag($Grid, "p_x" . $Grid->RowIndex . "_user_id") ?>
<script>
loadjs.ready("head", function() {
    var el = document.querySelector("select[data-select2-id='claim_signer_x<?= $Grid->RowIndex ?>_user_id']"),
        options = { name: "x<?= $Grid->RowIndex ?>_user_id", selectId: "claim_signer_x<?= $Grid->RowIndex ?>_user_id", language: ew.LANGUAGE_ID, dir: ew.IS_RTL ? "rtl" : "ltr" };
    options.dropdownParent = $(el).closest("#ew-modal-dialog, #ew-add-opt-dialog")[0];
    Object.assign(options, ew.vars.tables.claim_signer.fields.user_id.selectOptions);
    ew.createSelect(options);
});
</script>
</span>
<?php } ?>
<input type="hidden" data-table="claim_signer" data-field="x_user_id" data-hidden="1" name="o<?= $Grid->RowIndex ?>_user_id" id="o<?= $Grid->RowIndex ?>_user_id" value="<?= HtmlEncode($Grid->user_id->OldValue) ?>">
<?php } ?>
<?php if ($Grid->RowType == ROWTYPE_EDIT) { // Edit record ?>
<?php if (!$Security->isAdmin() && $Security->isLoggedIn() && !$Grid->userIDAllow("grid")) { // Non system admin ?>
<span id="el<?= $Grid->RowCount ?>_claim_signer_user_id" class="form-group">
<span<?= $Grid->user_id->viewAttributes() ?>>
<input type="text" readonly class="form-control-plaintext" value="<?= HtmlEncode(RemoveHtml($Grid->user_id->getDisplayValue($Grid->user_id->EditValue))) ?>"></span>
</span>
<input type="hidden" data-table="claim_signer" data-field="x_user_id" data-hidden="1" name="x<?= $Grid->RowIndex ?>_user_id" id="x<?= $Grid->RowIndex ?>_user_id" value="<?= HtmlEncode($Grid->user_id->CurrentValue) ?>">
<?php } else { ?>
<span id="el<?= $Grid->RowCount ?>_claim_signer_user_id" class="form-group">
    <select
        id="x<?= $Grid->RowIndex ?>_user_id"
        name="x<?= $Grid->RowIndex ?>_user_id"
        class="form-control ew-select<?= $Grid->user_id->isInvalidClass() ?>"
        data-select2-id="claim_signer_x<?= $Grid->RowIndex ?>_user_id"
        data-table="claim_signer"
        data-field="x_user_id"
        data-value-separator="<?= $Grid->user_id->displayValueSeparatorAttribute() ?>"
        data-placeholder="<?= HtmlEncode($Grid->user_id->getPlaceHolder()) ?>"
        <?= $Grid->user_id->editAttributes() ?>>
        <?= $Grid->user_id->selectOptionListHtml("x{$Grid->RowIndex}_user_id") ?>
    </select>
    <div class="invalid-feedback"><?= $Grid->user_id->getErrorMessage() ?></div>
<?= $Grid->user_id->Lookup->getParamTag($Grid, "p_x" . $Grid->RowIndex . "_user_id") ?>
<script>
loadjs.ready("head", function() {
    var el = document.querySelector("select[data-select2-id='claim_signer_x<?= $Grid->RowIndex ?>_user_id']"),
        options = { name: "x<?= $Grid->RowIndex ?>_user_id", selectId: "claim_signer_x<?= $Grid->RowIndex ?>_user_id", language: ew.LANGUAGE_ID, dir: ew.IS_RTL ? "rtl" : "ltr" };
    options.dropdownParent = $(el).closest("#ew-modal-dialog, #ew-add-opt-dialog")[0];
    Object.assign(options, ew.vars.tables.claim_signer.fields.user_id.selectOptions);
    ew.createSelect(options);
});
</script>
</span>
<?php } ?>
<?php } ?>
<?php if ($Grid->RowType == ROWTYPE_VIEW) { // View record ?>
<span id="el<?= $Grid->RowCount ?>_claim_signer_user_id">
<span<?= $Grid->user_id->viewAttributes() ?>>
<?= $Grid->user_id->getViewValue() ?></span>
</span>
<?php if ($Grid->isConfirm()) { ?>
<input type="hidden" data-table="claim_signer" data-field="x_user_id" data-hidden="1" name="fclaim_signergrid$x<?= $Grid->RowIndex ?>_user_id" id="fclaim_signergrid$x<?= $Grid->RowIndex ?>_user_id" value="<?= HtmlEncode($Grid->user_id->FormValue) ?>">
<input type="hidden" data-table="claim_signer" data-field="x_user_id" data-hidden="1" name="fclaim_signergrid$o<?= $Grid->RowIndex ?>_user_id" id="fclaim_signergrid$o<?= $Grid->RowIndex ?>_user_id" value="<?= HtmlEncode($Grid->user_id->OldValue) ?>">
<?php } ?>
<?php } ?>
</td>
    <?php } ?>
    <?php if ($Grid->signed->Visible) { // signed ?>
        <td data-name="signed" <?= $Grid->signed->cellAttributes() ?>>
<?php if ($Grid->RowType == ROWTYPE_ADD) { // Add record ?>
<span id="el<?= $Grid->RowCount ?>_claim_signer_signed" class="form-group">
<template id="tp_x<?= $Grid->RowIndex ?>_signed">
    <div class="custom-control custom-radio">
        <input type="radio" class="custom-control-input" data-table="claim_signer" data-field="x_signed" name="x<?= $Grid->RowIndex ?>_signed" id="x<?= $Grid->RowIndex ?>_signed"<?= $Grid->signed->editAttributes() ?>>
        <label class="custom-control-label"></label>
    </div>
</template>
<div id="dsl_x<?= $Grid->RowIndex ?>_signed" class="ew-item-list"></div>
<input type="hidden"
    is="selection-list"
    id="x<?= $Grid->RowIndex ?>_signed"
    name="x<?= $Grid->RowIndex ?>_signed"
    value="<?= HtmlEncode($Grid->signed->CurrentValue) ?>"
    data-type="select-one"
    data-template="tp_x<?= $Grid->RowIndex ?>_signed"
    data-target="dsl_x<?= $Grid->RowIndex ?>_signed"
    data-repeatcolumn="5"
    class="form-control<?= $Grid->signed->isInvalidClass() ?>"
    data-table="claim_signer"
    data-field="x_signed"
    data-value-separator="<?= $Grid->signed->displayValueSeparatorAttribute() ?>"
    <?= $Grid->signed->editAttributes() ?>>
<div class="invalid-feedback"><?= $Grid->signed->getErrorMessage() ?></div>
</span>
<input type="hidden" data-table="claim_signer" data-field="x_signed" data-hidden="1" name="o<?= $Grid->RowIndex ?>_signed" id="o<?= $Grid->RowIndex ?>_signed" value="<?= HtmlEncode($Grid->signed->OldValue) ?>">
<?php } ?>
<?php if ($Grid->RowType == ROWTYPE_EDIT) { // Edit record ?>
<span id="el<?= $Grid->RowCount ?>_claim_signer_signed" class="form-group">
<template id="tp_x<?= $Grid->RowIndex ?>_signed">
    <div class="custom-control custom-radio">
        <input type="radio" class="custom-control-input" data-table="claim_signer" data-field="x_signed" name="x<?= $Grid->RowIndex ?>_signed" id="x<?= $Grid->RowIndex ?>_signed"<?= $Grid->signed->editAttributes() ?>>
        <label class="custom-control-label"></label>
    </div>
</template>
<div id="dsl_x<?= $Grid->RowIndex ?>_signed" class="ew-item-list"></div>
<input type="hidden"
    is="selection-list"
    id="x<?= $Grid->RowIndex ?>_signed"
    name="x<?= $Grid->RowIndex ?>_signed"
    value="<?= HtmlEncode($Grid->signed->CurrentValue) ?>"
    data-type="select-one"
    data-template="tp_x<?= $Grid->RowIndex ?>_signed"
    data-target="dsl_x<?= $Grid->RowIndex ?>_signed"
    data-repeatcolumn="5"
    class="form-control<?= $Grid->signed->isInvalidClass() ?>"
    data-table="claim_signer"
    data-field="x_signed"
    data-value-separator="<?= $Grid->signed->displayValueSeparatorAttribute() ?>"
    <?= $Grid->signed->editAttributes() ?>>
<div class="invalid-feedback"><?= $Grid->signed->getErrorMessage() ?></div>
</span>
<?php } ?>
<?php if ($Grid->RowType == ROWTYPE_VIEW) { // View record ?>
<span id="el<?= $Grid->RowCount ?>_claim_signer_signed">
<span<?= $Grid->signed->viewAttributes() ?>>
<?= $Grid->signed->getViewValue() ?></span>
</span>
<?php if ($Grid->isConfirm()) { ?>
<input type="hidden" data-table="claim_signer" data-field="x_signed" data-hidden="1" name="fclaim_signergrid$x<?= $Grid->RowIndex ?>_signed" id="fclaim_signergrid$x<?= $Grid->RowIndex ?>_signed" value="<?= HtmlEncode($Grid->signed->FormValue) ?>">
<input type="hidden" data-table="claim_signer" data-field="x_signed" data-hidden="1" name="fclaim_signergrid$o<?= $Grid->RowIndex ?>_signed" id="fclaim_signergrid$o<?= $Grid->RowIndex ?>_signed" value="<?= HtmlEncode($Grid->signed->OldValue) ?>">
<?php } ?>
<?php } ?>
</td>
    <?php } ?>
<?php
// Render list options (body, right)
$Grid->ListOptions->render("body", "right", $Grid->RowCount);
?>
    </tr>
<?php if ($Grid->RowType == ROWTYPE_ADD || $Grid->RowType == ROWTYPE_EDIT) { ?>
<script>
loadjs.ready(["fclaim_signergrid","load"], function () {
    fclaim_signergrid.updateLists(<?= $Grid->RowIndex ?>);
});
</script>
<?php } ?>
<?php
    }
    } // End delete row checking
    if (!$Grid->isGridAdd() || $Grid->CurrentMode == "copy")
        if (!$Grid->Recordset->EOF) {
            $Grid->Recordset->moveNext();
        }
}
?>
<?php
    if ($Grid->CurrentMode == "add" || $Grid->CurrentMode == "copy" || $Grid->CurrentMode == "edit") {
        $Grid->RowIndex = '$rowindex$';
        $Grid->loadRowValues();

        // Set row properties
        $Grid->resetAttributes();
        $Grid->RowAttrs->merge(["data-rowindex" => $Grid->RowIndex, "id" => "r0_claim_signer", "data-rowtype" => ROWTYPE_ADD]);
        $Grid->RowAttrs->appendClass("ew-template");
        $Grid->RowType = ROWTYPE_ADD;

        // Render row
        $Grid->renderRow();

        // Render list options
        $Grid->renderListOptions();
        $Grid->StartRowCount = 0;
?>
    <tr <?= $Grid->rowAttributes() ?>>
<?php
// Render list options (body, left)
$Grid->ListOptions->render("body", "left", $Grid->RowIndex);
?>
    <?php if ($Grid->claim_id->Visible) { // claim_id ?>
        <td data-name="claim_id">
<?php if (!$Grid->isConfirm()) { ?>
<?php if ($Grid->claim_id->getSessionValue() != "") { ?>
<span id="el$rowindex$_claim_signer_claim_id" class="form-group claim_signer_claim_id">
<span<?= $Grid->claim_id->viewAttributes() ?>>
<input type="text" readonly class="form-control-plaintext" value="<?= HtmlEncode(RemoveHtml($Grid->claim_id->getDisplayValue($Grid->claim_id->ViewValue))) ?>"></span>
</span>
<input type="hidden" id="x<?= $Grid->RowIndex ?>_claim_id" name="x<?= $Grid->RowIndex ?>_claim_id" value="<?= HtmlEncode($Grid->claim_id->CurrentValue) ?>" data-hidden="1">
<?php } else { ?>
<span id="el$rowindex$_claim_signer_claim_id" class="form-group claim_signer_claim_id">
<input type="<?= $Grid->claim_id->getInputTextType() ?>" data-table="claim_signer" data-field="x_claim_id" name="x<?= $Grid->RowIndex ?>_claim_id" id="x<?= $Grid->RowIndex ?>_claim_id" size="30" maxlength="11" placeholder="<?= HtmlEncode($Grid->claim_id->getPlaceHolder()) ?>" value="<?= $Grid->claim_id->EditValue ?>"<?= $Grid->claim_id->editAttributes() ?>>
<div class="invalid-feedback"><?= $Grid->claim_id->getErrorMessage() ?></div>
</span>
<?php } ?>
<?php } else { ?>
<span id="el$rowindex$_claim_signer_claim_id" class="form-group claim_signer_claim_id">
<span<?= $Grid->claim_id->viewAttributes() ?>>
<input type="text" readonly class="form-control-plaintext" value="<?= HtmlEncode(RemoveHtml($Grid->claim_id->getDisplayValue($Grid->claim_id->ViewValue))) ?>"></span>
</span>
<input type="hidden" data-table="claim_signer" data-field="x_claim_id" data-hidden="1" name="x<?= $Grid->RowIndex ?>_claim_id" id="x<?= $Grid->RowIndex ?>_claim_id" value="<?= HtmlEncode($Grid->claim_id->FormValue) ?>">
<?php } ?>
<input type="hidden" data-table="claim_signer" data-field="x_claim_id" data-hidden="1" name="o<?= $Grid->RowIndex ?>_claim_id" id="o<?= $Grid->RowIndex ?>_claim_id" value="<?= HtmlEncode($Grid->claim_id->OldValue) ?>">
</td>
    <?php } ?>
    <?php if ($Grid->user_id->Visible) { // user_id ?>
        <td data-name="user_id">
<?php if (!$Grid->isConfirm()) { ?>
<?php if (!$Security->isAdmin() && $Security->isLoggedIn() && !$Grid->userIDAllow("grid")) { // Non system admin ?>
<span id="el$rowindex$_claim_signer_user_id" class="form-group claim_signer_user_id">
<span<?= $Grid->user_id->viewAttributes() ?>>
<input type="text" readonly class="form-control-plaintext" value="<?= HtmlEncode(RemoveHtml($Grid->user_id->getDisplayValue($Grid->user_id->EditValue))) ?>"></span>
</span>
<input type="hidden" data-table="claim_signer" data-field="x_user_id" data-hidden="1" name="x<?= $Grid->RowIndex ?>_user_id" id="x<?= $Grid->RowIndex ?>_user_id" value="<?= HtmlEncode($Grid->user_id->CurrentValue) ?>">
<?php } else { ?>
<span id="el$rowindex$_claim_signer_user_id" class="form-group claim_signer_user_id">
    <select
        id="x<?= $Grid->RowIndex ?>_user_id"
        name="x<?= $Grid->RowIndex ?>_user_id"
        class="form-control ew-select<?= $Grid->user_id->isInvalidClass() ?>"
        data-select2-id="claim_signer_x<?= $Grid->RowIndex ?>_user_id"
        data-table="claim_signer"
        data-field="x_user_id"
        data-value-separator="<?= $Grid->user_id->displayValueSeparatorAttribute() ?>"
        data-placeholder="<?= HtmlEncode($Grid->user_id->getPlaceHolder()) ?>"
        <?= $Grid->user_id->editAttributes() ?>>
        <?= $Grid->user_id->selectOptionListHtml("x{$Grid->RowIndex}_user_id") ?>
    </select>
    <div class="invalid-feedback"><?= $Grid->user_id->getErrorMessage() ?></div>
<?= $Grid->user_id->Lookup->getParamTag($Grid, "p_x" . $Grid->RowIndex . "_user_id") ?>
<script>
loadjs.ready("head", function() {
    var el = document.querySelector("select[data-select2-id='claim_signer_x<?= $Grid->RowIndex ?>_user_id']"),
        options = { name: "x<?= $Grid->RowIndex ?>_user_id", selectId: "claim_signer_x<?= $Grid->RowIndex ?>_user_id", language: ew.LANGUAGE_ID, dir: ew.IS_RTL ? "rtl" : "ltr" };
    options.dropdownParent = $(el).closest("#ew-modal-dialog, #ew-add-opt-dialog")[0];
    Object.assign(options, ew.vars.tables.claim_signer.fields.user_id.selectOptions);
    ew.createSelect(options);
});
</script>
</span>
<?php } ?>
<?php } else { ?>
<span id="el$rowindex$_claim_signer_user_id" class="form-group claim_signer_user_id">
<span<?= $Grid->user_id->viewAttributes() ?>>
<input type="text" readonly class="form-control-plaintext" value="<?= HtmlEncode(RemoveHtml($Grid->user_id->getDisplayValue($Grid->user_id->ViewValue))) ?>"></span>
</span>
<input type="hidden" data-table="claim_signer" data-field="x_user_id" data-hidden="1" name="x<?= $Grid->RowIndex ?>_user_id" id="x<?= $Grid->RowIndex ?>_user_id" value="<?= HtmlEncode($Grid->user_id->FormValue) ?>">
<?php } ?>
<input type="hidden" data-table="claim_signer" data-field="x_user_id" data-hidden="1" name="o<?= $Grid->RowIndex ?>_user_id" id="o<?= $Grid->RowIndex ?>_user_id" value="<?= HtmlEncode($Grid->user_id->OldValue) ?>">
</td>
    <?php } ?>
    <?php if ($Grid->signed->Visible) { // signed ?>
        <td data-name="signed">
<?php if (!$Grid->isConfirm()) { ?>
<span id="el$rowindex$_claim_signer_signed" class="form-group claim_signer_signed">
<template id="tp_x<?= $Grid->RowIndex ?>_signed">
    <div class="custom-control custom-radio">
        <input type="radio" class="custom-control-input" data-table="claim_signer" data-field="x_signed" name="x<?= $Grid->RowIndex ?>_signed" id="x<?= $Grid->RowIndex ?>_signed"<?= $Grid->signed->editAttributes() ?>>
        <label class="custom-control-label"></label>
    </div>
</template>
<div id="dsl_x<?= $Grid->RowIndex ?>_signed" class="ew-item-list"></div>
<input type="hidden"
    is="selection-list"
    id="x<?= $Grid->RowIndex ?>_signed"
    name="x<?= $Grid->RowIndex ?>_signed"
    value="<?= HtmlEncode($Grid->signed->CurrentValue) ?>"
    data-type="select-one"
    data-template="tp_x<?= $Grid->RowIndex ?>_signed"
    data-target="dsl_x<?= $Grid->RowIndex ?>_signed"
    data-repeatcolumn="5"
    class="form-control<?= $Grid->signed->isInvalidClass() ?>"
    data-table="claim_signer"
    data-field="x_signed"
    data-value-separator="<?= $Grid->signed->displayValueSeparatorAttribute() ?>"
    <?= $Grid->signed->editAttributes() ?>>
<div class="invalid-feedback"><?= $Grid->signed->getErrorMessage() ?></div>
</span>
<?php } else { ?>
<span id="el$rowindex$_claim_signer_signed" class="form-group claim_signer_signed">
<span<?= $Grid->signed->viewAttributes() ?>>
<input type="text" readonly class="form-control-plaintext" value="<?= HtmlEncode(RemoveHtml($Grid->signed->getDisplayValue($Grid->signed->ViewValue))) ?>"></span>
</span>
<input type="hidden" data-table="claim_signer" data-field="x_signed" data-hidden="1" name="x<?= $Grid->RowIndex ?>_signed" id="x<?= $Grid->RowIndex ?>_signed" value="<?= HtmlEncode($Grid->signed->FormValue) ?>">
<?php } ?>
<input type="hidden" data-table="claim_signer" data-field="x_signed" data-hidden="1" name="o<?= $Grid->RowIndex ?>_signed" id="o<?= $Grid->RowIndex ?>_signed" value="<?= HtmlEncode($Grid->signed->OldValue) ?>">
</td>
    <?php } ?>
<?php
// Render list options (body, right)
$Grid->ListOptions->render("body", "right", $Grid->RowIndex);
?>
<script>
loadjs.ready(["fclaim_signergrid","load"], function() {
    fclaim_signergrid.updateLists(<?= $Grid->RowIndex ?>);
});
</script>
    </tr>
<?php
    }
?>
</tbody>
</table><!-- /.ew-table -->
</div><!-- /.ew-grid-middle-panel -->
<?php if ($Grid->CurrentMode == "add" || $Grid->CurrentMode == "copy") { ?>
<input type="hidden" name="<?= $Grid->FormKeyCountName ?>" id="<?= $Grid->FormKeyCountName ?>" value="<?= $Grid->KeyCount ?>">
<?= $Grid->MultiSelectKey ?>
<?php } ?>
<?php if ($Grid->CurrentMode == "edit") { ?>
<input type="hidden" name="<?= $Grid->FormKeyCountName ?>" id="<?= $Grid->FormKeyCountName ?>" value="<?= $Grid->KeyCount ?>">
<?= $Grid->MultiSelectKey ?>
<?php } ?>
<?php if ($Grid->CurrentMode == "") { ?>
<input type="hidden" name="action" id="action" value="">
<?php } ?>
<input type="hidden" name="detailpage" value="fclaim_signergrid">
</div><!-- /.ew-list-form -->
<?php
// Close recordset
if ($Grid->Recordset) {
    $Grid->Recordset->close();
}
?>
<?php if ($Grid->ShowOtherOptions) { ?>
<div class="card-footer ew-grid-lower-panel">
<?php $Grid->OtherOptions->render("body", "bottom") ?>
</div>
<div class="clearfix"></div>
<?php } ?>
</div><!-- /.ew-grid -->
<?php } ?>
<?php if ($Grid->TotalRecords == 0 && !$Grid->CurrentAction) { // Show other options ?>
<div class="ew-list-other-options">
<?php $Grid->OtherOptions->render("body") ?>
</div>
<div class="clearfix"></div>
<?php } ?>
<?php if (!$Grid->isExport()) { ?>
<script>
// Field event handlers
loadjs.ready("head", function() {
    ew.addEventHandlers("claim_signer");
});
</script>
<script>
loadjs.ready("load", function () {
    // Write your table-specific startup script here, no need to add script tags.
});
</script>
<?php } ?>
