<?php

namespace PHPMaker2021\educlaims;

// Page object
$ClaimsAdd = &$Page;
?>
<script>
var currentForm, currentPageID;
var fclaimsadd;
loadjs.ready("head", function () {
    var $ = jQuery;
    // Form object
    currentPageID = ew.PAGE_ID = "add";
    fclaimsadd = currentForm = new ew.Form("fclaimsadd", "add");

    // Add fields
    var currentTable = <?= JsonEncode(GetClientVar("tables", "claims")) ?>,
        fields = currentTable.fields;
    if (!ew.vars.tables.claims)
        ew.vars.tables.claims = currentTable;
    fclaimsadd.addFields([
        ["initiator", [fields.initiator.visible && fields.initiator.required ? ew.Validators.required(fields.initiator.caption) : null], fields.initiator.isInvalid],
        ["subject", [fields.subject.visible && fields.subject.required ? ew.Validators.required(fields.subject.caption) : null], fields.subject.isInvalid],
        ["category", [fields.category.visible && fields.category.required ? ew.Validators.required(fields.category.caption) : null], fields.category.isInvalid],
        ["title", [fields.title.visible && fields.title.required ? ew.Validators.required(fields.title.caption) : null], fields.title.isInvalid],
        ["_content", [fields._content.visible && fields._content.required ? ew.Validators.required(fields._content.caption) : null], fields._content.isInvalid],
        ["signers", [fields.signers.visible && fields.signers.required ? ew.Validators.required(fields.signers.caption) : null], fields.signers.isInvalid]
    ]);

    // Set invalid fields
    $(function() {
        var f = fclaimsadd,
            fobj = f.getForm(),
            $fobj = $(fobj),
            $k = $fobj.find("#" + f.formKeyCountName), // Get key_count
            rowcnt = ($k[0]) ? parseInt($k.val(), 10) : 1,
            startcnt = (rowcnt == 0) ? 0 : 1; // Check rowcnt == 0 => Inline-Add
        for (var i = startcnt; i <= rowcnt; i++) {
            var rowIndex = ($k[0]) ? String(i) : "";
            f.setInvalid(rowIndex);
        }
    });

    // Validate form
    fclaimsadd.validate = function () {
        if (!this.validateRequired)
            return true; // Ignore validation
        var fobj = this.getForm(),
            $fobj = $(fobj);
        if ($fobj.find("#confirm").val() == "confirm")
            return true;
        var addcnt = 0,
            $k = $fobj.find("#" + this.formKeyCountName), // Get key_count
            rowcnt = ($k[0]) ? parseInt($k.val(), 10) : 1,
            startcnt = (rowcnt == 0) ? 0 : 1, // Check rowcnt == 0 => Inline-Add
            gridinsert = ["insert", "gridinsert"].includes($fobj.find("#action").val()) && $k[0];
        for (var i = startcnt; i <= rowcnt; i++) {
            var rowIndex = ($k[0]) ? String(i) : "";
            $fobj.data("rowindex", rowIndex);

            // Validate fields
            if (!this.validateFields(rowIndex))
                return false;

            // Call Form_CustomValidate event
            if (!this.customValidate(fobj)) {
                this.focus();
                return false;
            }
        }

        // Process detail forms
        var dfs = $fobj.find("input[name='detailpage']").get();
        for (var i = 0; i < dfs.length; i++) {
            var df = dfs[i],
                val = df.value,
                frm = ew.forms.get(val);
            if (val && frm && !frm.validate())
                return false;
        }
        return true;
    }

    // Form_CustomValidate
    fclaimsadd.customValidate = function(fobj) { // DO NOT CHANGE THIS LINE!
        // Your custom validation code here, return false if invalid.
        return true;
    }

    // Use JavaScript validation or not
    fclaimsadd.validateRequired = <?= Config("CLIENT_VALIDATE") ? "true" : "false" ?>;

    // Multi-Page
    fclaimsadd.multiPage = new ew.MultiPage("fclaimsadd");

    // Dynamic selection lists
    fclaimsadd.lists.subject = <?= $Page->subject->toClientList($Page) ?>;
    fclaimsadd.lists.category = <?= $Page->category->toClientList($Page) ?>;
    fclaimsadd.lists.signers = <?= $Page->signers->toClientList($Page) ?>;
    loadjs.done("fclaimsadd");
});
</script>
<script>
loadjs.ready("head", function () {
    // Write your table-specific client script here, no need to add script tags.
});
</script>
<?php $Page->showPageHeader(); ?>
<?php
$Page->showMessage();
?>
<form name="fclaimsadd" id="fclaimsadd" class="<?= $Page->FormClassName ?>" action="<?= CurrentPageUrl(false) ?>" method="post">
<?php if (Config("CHECK_TOKEN")) { ?>
<input type="hidden" name="<?= $TokenNameKey ?>" value="<?= $TokenName ?>"><!-- CSRF token name -->
<input type="hidden" name="<?= $TokenValueKey ?>" value="<?= $TokenValue ?>"><!-- CSRF token value -->
<?php } ?>
<input type="hidden" name="t" value="claims">
<input type="hidden" name="action" id="action" value="insert">
<input type="hidden" name="modal" value="<?= (int)$Page->IsModal ?>">
<input type="hidden" name="<?= $Page->OldKeyName ?>" value="<?= $Page->OldKey ?>">
<div class="ew-multi-page"><!-- multi-page -->
<div class="ew-nav-tabs" id="Page"><!-- multi-page tabs -->
    <ul class="<?= $Page->MultiPages->navStyle() ?>">
        <li class="nav-item"><a class="nav-link<?= $Page->MultiPages->pageStyle(1) ?>" href="#tab_claims1" data-toggle="tab"><?= $Page->pageCaption(1) ?></a></li>
        <li class="nav-item"><a class="nav-link<?= $Page->MultiPages->pageStyle(2) ?>" href="#tab_claims2" data-toggle="tab"><?= $Page->pageCaption(2) ?></a></li>
        <li class="nav-item"><a class="nav-link<?= $Page->MultiPages->pageStyle(3) ?>" href="#tab_claims3" data-toggle="tab"><?= $Page->pageCaption(3) ?></a></li>
    </ul>
    <div class="tab-content"><!-- multi-page tabs .tab-content -->
        <div class="tab-pane<?= $Page->MultiPages->pageStyle(1) ?>" id="tab_claims1"><!-- multi-page .tab-pane -->
<div class="ew-add-div"><!-- page* -->
    <span id="el_claims_initiator">
    <input type="hidden" data-table="claims" data-field="x_initiator" data-hidden="1" data-page="1" name="x_initiator" id="x_initiator" value="<?= HtmlEncode($Page->initiator->CurrentValue) ?>">
    </span>
<?php if ($Page->subject->Visible) { // subject ?>
    <div id="r_subject" class="form-group row">
        <label id="elh_claims_subject" for="x_subject" class="<?= $Page->LeftColumnClass ?>"><?= $Page->subject->caption() ?><?= $Page->subject->Required ? $Language->phrase("FieldRequiredIndicator") : "" ?></label>
        <div class="<?= $Page->RightColumnClass ?>"><div <?= $Page->subject->cellAttributes() ?>>
<span id="el_claims_subject">
    <select
        id="x_subject"
        name="x_subject"
        class="form-control ew-select<?= $Page->subject->isInvalidClass() ?>"
        data-select2-id="claims_x_subject"
        data-table="claims"
        data-field="x_subject"
        data-page="1"
        data-value-separator="<?= $Page->subject->displayValueSeparatorAttribute() ?>"
        data-placeholder="<?= HtmlEncode($Page->subject->getPlaceHolder()) ?>"
        <?= $Page->subject->editAttributes() ?>>
        <?= $Page->subject->selectOptionListHtml("x_subject") ?>
    </select>
    <?= $Page->subject->getCustomMessage() ?>
    <div class="invalid-feedback"><?= $Page->subject->getErrorMessage() ?></div>
<?= $Page->subject->Lookup->getParamTag($Page, "p_x_subject") ?>
<script>
loadjs.ready("head", function() {
    var el = document.querySelector("select[data-select2-id='claims_x_subject']"),
        options = { name: "x_subject", selectId: "claims_x_subject", language: ew.LANGUAGE_ID, dir: ew.IS_RTL ? "rtl" : "ltr" };
    options.dropdownParent = $(el).closest("#ew-modal-dialog, #ew-add-opt-dialog")[0];
    Object.assign(options, ew.vars.tables.claims.fields.subject.selectOptions);
    ew.createSelect(options);
});
</script>
</span>
</div></div>
    </div>
<?php } ?>
<?php if ($Page->category->Visible) { // category ?>
    <div id="r_category" class="form-group row">
        <label id="elh_claims_category" for="x_category" class="<?= $Page->LeftColumnClass ?>"><?= $Page->category->caption() ?><?= $Page->category->Required ? $Language->phrase("FieldRequiredIndicator") : "" ?></label>
        <div class="<?= $Page->RightColumnClass ?>"><div <?= $Page->category->cellAttributes() ?>>
<span id="el_claims_category">
    <select
        id="x_category"
        name="x_category"
        class="form-control ew-select<?= $Page->category->isInvalidClass() ?>"
        data-select2-id="claims_x_category"
        data-table="claims"
        data-field="x_category"
        data-page="1"
        data-value-separator="<?= $Page->category->displayValueSeparatorAttribute() ?>"
        data-placeholder="<?= HtmlEncode($Page->category->getPlaceHolder()) ?>"
        <?= $Page->category->editAttributes() ?>>
        <?= $Page->category->selectOptionListHtml("x_category") ?>
    </select>
    <?= $Page->category->getCustomMessage() ?>
    <div class="invalid-feedback"><?= $Page->category->getErrorMessage() ?></div>
<?= $Page->category->Lookup->getParamTag($Page, "p_x_category") ?>
<script>
loadjs.ready("head", function() {
    var el = document.querySelector("select[data-select2-id='claims_x_category']"),
        options = { name: "x_category", selectId: "claims_x_category", language: ew.LANGUAGE_ID, dir: ew.IS_RTL ? "rtl" : "ltr" };
    options.dropdownParent = $(el).closest("#ew-modal-dialog, #ew-add-opt-dialog")[0];
    Object.assign(options, ew.vars.tables.claims.fields.category.selectOptions);
    ew.createSelect(options);
});
</script>
</span>
</div></div>
    </div>
<?php } ?>
<?php if ($Page->title->Visible) { // title ?>
    <div id="r_title" class="form-group row">
        <label id="elh_claims_title" for="x_title" class="<?= $Page->LeftColumnClass ?>"><?= $Page->title->caption() ?><?= $Page->title->Required ? $Language->phrase("FieldRequiredIndicator") : "" ?></label>
        <div class="<?= $Page->RightColumnClass ?>"><div <?= $Page->title->cellAttributes() ?>>
<span id="el_claims_title">
<input type="<?= $Page->title->getInputTextType() ?>" data-table="claims" data-field="x_title" data-page="1" name="x_title" id="x_title" maxlength="512" placeholder="<?= HtmlEncode($Page->title->getPlaceHolder()) ?>" value="<?= $Page->title->EditValue ?>"<?= $Page->title->editAttributes() ?> aria-describedby="x_title_help">
<?= $Page->title->getCustomMessage() ?>
<div class="invalid-feedback"><?= $Page->title->getErrorMessage() ?></div>
</span>
</div></div>
    </div>
<?php } ?>
</div><!-- /page* -->
        </div><!-- /multi-page .tab-pane -->
        <div class="tab-pane<?= $Page->MultiPages->pageStyle(2) ?>" id="tab_claims2"><!-- multi-page .tab-pane -->
<div class="ew-add-div"><!-- page* -->
<?php if ($Page->_content->Visible) { // content ?>
    <div id="r__content" class="form-group row">
        <label id="elh_claims__content" for="x__content" class="<?= $Page->LeftColumnClass ?>"><?= $Page->_content->caption() ?><?= $Page->_content->Required ? $Language->phrase("FieldRequiredIndicator") : "" ?></label>
        <div class="<?= $Page->RightColumnClass ?>"><div <?= $Page->_content->cellAttributes() ?>>
<span id="el_claims__content">
<textarea data-table="claims" data-field="x__content" data-page="2" name="x__content" id="x__content" cols="50" rows="10" placeholder="<?= HtmlEncode($Page->_content->getPlaceHolder()) ?>"<?= $Page->_content->editAttributes() ?> aria-describedby="x__content_help"><?= $Page->_content->EditValue ?></textarea>
<?= $Page->_content->getCustomMessage() ?>
<div class="invalid-feedback"><?= $Page->_content->getErrorMessage() ?></div>
</span>
</div></div>
    </div>
<?php } ?>
</div><!-- /page* -->
        </div><!-- /multi-page .tab-pane -->
        <div class="tab-pane<?= $Page->MultiPages->pageStyle(3) ?>" id="tab_claims3"><!-- multi-page .tab-pane -->
<div class="ew-add-div"><!-- page* -->
<?php if ($Page->signers->Visible) { // signers ?>
    <div id="r_signers" class="form-group row">
        <label id="elh_claims_signers" class="<?= $Page->LeftColumnClass ?>"><?= $Page->signers->caption() ?><?= $Page->signers->Required ? $Language->phrase("FieldRequiredIndicator") : "" ?></label>
        <div class="<?= $Page->RightColumnClass ?>"><div <?= $Page->signers->cellAttributes() ?>>
<span id="el_claims_signers">
<div class="input-group ew-lookup-list" aria-describedby="x_signers_help">
    <div class="form-control ew-lookup-text" tabindex="-1" id="lu_x_signers"><?= EmptyValue(strval($Page->signers->ViewValue)) ? $Language->phrase("PleaseSelect") : $Page->signers->ViewValue ?></div>
    <div class="input-group-append">
        <button type="button" title="<?= HtmlEncode(str_replace("%s", RemoveHtml($Page->signers->caption()), $Language->phrase("LookupLink", true))) ?>" class="ew-lookup-btn btn btn-default"<?= ($Page->signers->ReadOnly || $Page->signers->Disabled) ? " disabled" : "" ?> onclick="ew.modalLookupShow({lnk:this,el:'x_signers[]',m:1,n:10});"><i class="fas fa-search ew-icon"></i></button>
    </div>
</div>
<div class="invalid-feedback"><?= $Page->signers->getErrorMessage() ?></div>
<?= $Page->signers->getCustomMessage() ?>
<?= $Page->signers->Lookup->getParamTag($Page, "p_x_signers") ?>
<input type="hidden" is="selection-list" data-table="claims" data-field="x_signers" data-page="3" data-type="text" data-multiple="1" data-lookup="1" data-value-separator="<?= $Page->signers->displayValueSeparatorAttribute() ?>" name="x_signers[]" id="x_signers[]" value="<?= $Page->signers->CurrentValue ?>"<?= $Page->signers->editAttributes() ?>>
</span>
</div></div>
    </div>
<?php } ?>
</div><!-- /page* -->
        </div><!-- /multi-page .tab-pane -->
    </div><!-- /multi-page tabs .tab-content -->
</div><!-- /multi-page tabs -->
</div><!-- /multi-page -->
<?php if (!$Page->IsModal) { ?>
<div class="form-group row"><!-- buttons .form-group -->
    <div class="<?= $Page->OffsetColumnClass ?>"><!-- buttons offset -->
<button class="btn btn-primary ew-btn" name="btn-action" id="btn-action" type="submit"><?= $Language->phrase("AddBtn") ?></button>
<button class="btn btn-default ew-btn" name="btn-cancel" id="btn-cancel" type="button" data-href="<?= HtmlEncode(GetUrl($Page->getReturnUrl())) ?>"><?= $Language->phrase("CancelBtn") ?></button>
    </div><!-- /buttons offset -->
</div><!-- /buttons .form-group -->
<?php } ?>
</form>
<?php
$Page->showPageFooter();
echo GetDebugMessage();
?>
<script>
// Field event handlers
loadjs.ready("head", function() {
    ew.addEventHandlers("claims");
});
</script>
<script>
loadjs.ready("load", function () {
    // Write your table-specific startup script here, no need to add script tags.
});
</script>
