<?php

namespace PHPMaker2021\educlaims;

// Set up and run Grid object
$Grid = Container("SignerGrid");
$Grid->run();
?>
<?php if (!$Grid->isExport()) { ?>
<script>
var currentForm, currentPageID;
var fsignergrid;
loadjs.ready("head", function () {
    var $ = jQuery;
    // Form object
    fsignergrid = new ew.Form("fsignergrid", "grid");
    fsignergrid.formKeyCountName = '<?= $Grid->FormKeyCountName ?>';

    // Add fields
    var currentTable = <?= JsonEncode(GetClientVar("tables", "signer")) ?>,
        fields = currentTable.fields;
    if (!ew.vars.tables.signer)
        ew.vars.tables.signer = currentTable;
    fsignergrid.addFields([
        ["signer", [fields.signer.visible && fields.signer.required ? ew.Validators.required(fields.signer.caption) : null], fields.signer.isInvalid],
        ["signed", [fields.signed.visible && fields.signed.required ? ew.Validators.required(fields.signed.caption) : null], fields.signed.isInvalid],
        ["created_at", [fields.created_at.visible && fields.created_at.required ? ew.Validators.required(fields.created_at.caption) : null, ew.Validators.datetime(0)], fields.created_at.isInvalid]
    ]);

    // Set invalid fields
    $(function() {
        var f = fsignergrid,
            fobj = f.getForm(),
            $fobj = $(fobj),
            $k = $fobj.find("#" + f.formKeyCountName), // Get key_count
            rowcnt = ($k[0]) ? parseInt($k.val(), 10) : 1,
            startcnt = (rowcnt == 0) ? 0 : 1; // Check rowcnt == 0 => Inline-Add
        for (var i = startcnt; i <= rowcnt; i++) {
            var rowIndex = ($k[0]) ? String(i) : "";
            f.setInvalid(rowIndex);
        }
    });

    // Validate form
    fsignergrid.validate = function () {
        if (!this.validateRequired)
            return true; // Ignore validation
        var fobj = this.getForm(),
            $fobj = $(fobj);
        if ($fobj.find("#confirm").val() == "confirm")
            return true;
        var addcnt = 0,
            $k = $fobj.find("#" + this.formKeyCountName), // Get key_count
            rowcnt = ($k[0]) ? parseInt($k.val(), 10) : 1,
            startcnt = (rowcnt == 0) ? 0 : 1, // Check rowcnt == 0 => Inline-Add
            gridinsert = ["insert", "gridinsert"].includes($fobj.find("#action").val()) && $k[0];
        for (var i = startcnt; i <= rowcnt; i++) {
            var rowIndex = ($k[0]) ? String(i) : "";
            $fobj.data("rowindex", rowIndex);
            var checkrow = (gridinsert) ? !this.emptyRow(rowIndex) : true;
            if (checkrow) {
                addcnt++;

            // Validate fields
            if (!this.validateFields(rowIndex))
                return false;

            // Call Form_CustomValidate event
            if (!this.customValidate(fobj)) {
                this.focus();
                return false;
            }
            } // End Grid Add checking
        }
        return true;
    }

    // Check empty row
    fsignergrid.emptyRow = function (rowIndex) {
        var fobj = this.getForm();
        if (ew.valueChanged(fobj, rowIndex, "signer", false))
            return false;
        if (ew.valueChanged(fobj, rowIndex, "signed", true))
            return false;
        if (ew.valueChanged(fobj, rowIndex, "created_at", false))
            return false;
        return true;
    }

    // Form_CustomValidate
    fsignergrid.customValidate = function(fobj) { // DO NOT CHANGE THIS LINE!
        // Your custom validation code here, return false if invalid.
        return true;
    }

    // Use JavaScript validation or not
    fsignergrid.validateRequired = <?= Config("CLIENT_VALIDATE") ? "true" : "false" ?>;

    // Dynamic selection lists
    fsignergrid.lists.signer = <?= $Grid->signer->toClientList($Grid) ?>;
    fsignergrid.lists.signed = <?= $Grid->signed->toClientList($Grid) ?>;
    loadjs.done("fsignergrid");
});
</script>
<?php } ?>
<?php
$Grid->renderOtherOptions();
?>
<?php if ($Grid->TotalRecords > 0 || $Grid->CurrentAction) { ?>
<div class="card ew-card ew-grid<?php if ($Grid->isAddOrEdit()) { ?> ew-grid-add-edit<?php } ?> signer">
<div id="fsignergrid" class="ew-form ew-list-form form-inline">
<div id="gmp_signer" class="<?= ResponsiveTableClass() ?>card-body ew-grid-middle-panel">
<table id="tbl_signergrid" class="table ew-table"><!-- .ew-table -->
<thead>
    <tr class="ew-table-header">
<?php
// Header row
$Grid->RowType = ROWTYPE_HEADER;

// Render list options
$Grid->renderListOptions();

// Render list options (header, left)
$Grid->ListOptions->render("header", "left");
?>
<?php if ($Grid->signer->Visible) { // signer ?>
        <th data-name="signer" class="<?= $Grid->signer->headerCellClass() ?>"><div id="elh_signer_signer" class="signer_signer"><?= $Grid->renderSort($Grid->signer) ?></div></th>
<?php } ?>
<?php if ($Grid->signed->Visible) { // signed ?>
        <th data-name="signed" class="<?= $Grid->signed->headerCellClass() ?>"><div id="elh_signer_signed" class="signer_signed"><?= $Grid->renderSort($Grid->signed) ?></div></th>
<?php } ?>
<?php if ($Grid->created_at->Visible) { // created_at ?>
        <th data-name="created_at" class="<?= $Grid->created_at->headerCellClass() ?>"><div id="elh_signer_created_at" class="signer_created_at"><?= $Grid->renderSort($Grid->created_at) ?></div></th>
<?php } ?>
<?php
// Render list options (header, right)
$Grid->ListOptions->render("header", "right");
?>
    </tr>
</thead>
<tbody>
<?php
$Grid->StartRecord = 1;
$Grid->StopRecord = $Grid->TotalRecords; // Show all records

// Restore number of post back records
if ($CurrentForm && ($Grid->isConfirm() || $Grid->EventCancelled)) {
    $CurrentForm->Index = -1;
    if ($CurrentForm->hasValue($Grid->FormKeyCountName) && ($Grid->isGridAdd() || $Grid->isGridEdit() || $Grid->isConfirm())) {
        $Grid->KeyCount = $CurrentForm->getValue($Grid->FormKeyCountName);
        $Grid->StopRecord = $Grid->StartRecord + $Grid->KeyCount - 1;
    }
}
$Grid->RecordCount = $Grid->StartRecord - 1;
if ($Grid->Recordset && !$Grid->Recordset->EOF) {
    // Nothing to do
} elseif (!$Grid->AllowAddDeleteRow && $Grid->StopRecord == 0) {
    $Grid->StopRecord = $Grid->GridAddRowCount;
}

// Initialize aggregate
$Grid->RowType = ROWTYPE_AGGREGATEINIT;
$Grid->resetAttributes();
$Grid->renderRow();
if ($Grid->isGridAdd())
    $Grid->RowIndex = 0;
if ($Grid->isGridEdit())
    $Grid->RowIndex = 0;
while ($Grid->RecordCount < $Grid->StopRecord) {
    $Grid->RecordCount++;
    if ($Grid->RecordCount >= $Grid->StartRecord) {
        $Grid->RowCount++;
        if ($Grid->isGridAdd() || $Grid->isGridEdit() || $Grid->isConfirm()) {
            $Grid->RowIndex++;
            $CurrentForm->Index = $Grid->RowIndex;
            if ($CurrentForm->hasValue($Grid->FormActionName) && ($Grid->isConfirm() || $Grid->EventCancelled)) {
                $Grid->RowAction = strval($CurrentForm->getValue($Grid->FormActionName));
            } elseif ($Grid->isGridAdd()) {
                $Grid->RowAction = "insert";
            } else {
                $Grid->RowAction = "";
            }
        }

        // Set up key count
        $Grid->KeyCount = $Grid->RowIndex;

        // Init row class and style
        $Grid->resetAttributes();
        $Grid->CssClass = "";
        if ($Grid->isGridAdd()) {
            if ($Grid->CurrentMode == "copy") {
                $Grid->loadRowValues($Grid->Recordset); // Load row values
                $Grid->OldKey = $Grid->getKey(true); // Get from CurrentValue
            } else {
                $Grid->loadRowValues(); // Load default values
                $Grid->OldKey = "";
            }
        } else {
            $Grid->loadRowValues($Grid->Recordset); // Load row values
            $Grid->OldKey = $Grid->getKey(true); // Get from CurrentValue
        }
        $Grid->setKey($Grid->OldKey);
        $Grid->RowType = ROWTYPE_VIEW; // Render view
        if ($Grid->isGridAdd()) { // Grid add
            $Grid->RowType = ROWTYPE_ADD; // Render add
        }
        if ($Grid->isGridAdd() && $Grid->EventCancelled && !$CurrentForm->hasValue("k_blankrow")) { // Insert failed
            $Grid->restoreCurrentRowFormValues($Grid->RowIndex); // Restore form values
        }
        if ($Grid->isGridEdit()) { // Grid edit
            if ($Grid->EventCancelled) {
                $Grid->restoreCurrentRowFormValues($Grid->RowIndex); // Restore form values
            }
            if ($Grid->RowAction == "insert") {
                $Grid->RowType = ROWTYPE_ADD; // Render add
            } else {
                $Grid->RowType = ROWTYPE_EDIT; // Render edit
            }
        }
        if ($Grid->isGridEdit() && ($Grid->RowType == ROWTYPE_EDIT || $Grid->RowType == ROWTYPE_ADD) && $Grid->EventCancelled) { // Update failed
            $Grid->restoreCurrentRowFormValues($Grid->RowIndex); // Restore form values
        }
        if ($Grid->RowType == ROWTYPE_EDIT) { // Edit row
            $Grid->EditRowCount++;
        }
        if ($Grid->isConfirm()) { // Confirm row
            $Grid->restoreCurrentRowFormValues($Grid->RowIndex); // Restore form values
        }

        // Set up row id / data-rowindex
        $Grid->RowAttrs->merge(["data-rowindex" => $Grid->RowCount, "id" => "r" . $Grid->RowCount . "_signer", "data-rowtype" => $Grid->RowType]);

        // Render row
        $Grid->renderRow();

        // Render list options
        $Grid->renderListOptions();

        // Skip delete row / empty row for confirm page
        if ($Grid->RowAction != "delete" && $Grid->RowAction != "insertdelete" && !($Grid->RowAction == "insert" && $Grid->isConfirm() && $Grid->emptyRow())) {
?>
    <tr <?= $Grid->rowAttributes() ?>>
<?php
// Render list options (body, left)
$Grid->ListOptions->render("body", "left", $Grid->RowCount);
?>
    <?php if ($Grid->signer->Visible) { // signer ?>
        <td data-name="signer" <?= $Grid->signer->cellAttributes() ?>>
<?php if ($Grid->RowType == ROWTYPE_ADD) { // Add record ?>
<span id="el<?= $Grid->RowCount ?>_signer_signer" class="form-group">
    <select
        id="x<?= $Grid->RowIndex ?>_signer"
        name="x<?= $Grid->RowIndex ?>_signer"
        class="form-control ew-select<?= $Grid->signer->isInvalidClass() ?>"
        data-select2-id="signer_x<?= $Grid->RowIndex ?>_signer"
        data-table="signer"
        data-field="x_signer"
        data-value-separator="<?= $Grid->signer->displayValueSeparatorAttribute() ?>"
        data-placeholder="<?= HtmlEncode($Grid->signer->getPlaceHolder()) ?>"
        <?= $Grid->signer->editAttributes() ?>>
        <?= $Grid->signer->selectOptionListHtml("x{$Grid->RowIndex}_signer") ?>
    </select>
    <div class="invalid-feedback"><?= $Grid->signer->getErrorMessage() ?></div>
<?= $Grid->signer->Lookup->getParamTag($Grid, "p_x" . $Grid->RowIndex . "_signer") ?>
<script>
loadjs.ready("head", function() {
    var el = document.querySelector("select[data-select2-id='signer_x<?= $Grid->RowIndex ?>_signer']"),
        options = { name: "x<?= $Grid->RowIndex ?>_signer", selectId: "signer_x<?= $Grid->RowIndex ?>_signer", language: ew.LANGUAGE_ID, dir: ew.IS_RTL ? "rtl" : "ltr" };
    options.dropdownParent = $(el).closest("#ew-modal-dialog, #ew-add-opt-dialog")[0];
    Object.assign(options, ew.vars.tables.signer.fields.signer.selectOptions);
    ew.createSelect(options);
});
</script>
</span>
<input type="hidden" data-table="signer" data-field="x_signer" data-hidden="1" name="o<?= $Grid->RowIndex ?>_signer" id="o<?= $Grid->RowIndex ?>_signer" value="<?= HtmlEncode($Grid->signer->OldValue) ?>">
<?php } ?>
<?php if ($Grid->RowType == ROWTYPE_EDIT) { // Edit record ?>
<span id="el<?= $Grid->RowCount ?>_signer_signer" class="form-group">
    <select
        id="x<?= $Grid->RowIndex ?>_signer"
        name="x<?= $Grid->RowIndex ?>_signer"
        class="form-control ew-select<?= $Grid->signer->isInvalidClass() ?>"
        data-select2-id="signer_x<?= $Grid->RowIndex ?>_signer"
        data-table="signer"
        data-field="x_signer"
        data-value-separator="<?= $Grid->signer->displayValueSeparatorAttribute() ?>"
        data-placeholder="<?= HtmlEncode($Grid->signer->getPlaceHolder()) ?>"
        <?= $Grid->signer->editAttributes() ?>>
        <?= $Grid->signer->selectOptionListHtml("x{$Grid->RowIndex}_signer") ?>
    </select>
    <div class="invalid-feedback"><?= $Grid->signer->getErrorMessage() ?></div>
<?= $Grid->signer->Lookup->getParamTag($Grid, "p_x" . $Grid->RowIndex . "_signer") ?>
<script>
loadjs.ready("head", function() {
    var el = document.querySelector("select[data-select2-id='signer_x<?= $Grid->RowIndex ?>_signer']"),
        options = { name: "x<?= $Grid->RowIndex ?>_signer", selectId: "signer_x<?= $Grid->RowIndex ?>_signer", language: ew.LANGUAGE_ID, dir: ew.IS_RTL ? "rtl" : "ltr" };
    options.dropdownParent = $(el).closest("#ew-modal-dialog, #ew-add-opt-dialog")[0];
    Object.assign(options, ew.vars.tables.signer.fields.signer.selectOptions);
    ew.createSelect(options);
});
</script>
</span>
<?php } ?>
<?php if ($Grid->RowType == ROWTYPE_VIEW) { // View record ?>
<span id="el<?= $Grid->RowCount ?>_signer_signer">
<span<?= $Grid->signer->viewAttributes() ?>>
<?= $Grid->signer->getViewValue() ?></span>
</span>
<?php if ($Grid->isConfirm()) { ?>
<input type="hidden" data-table="signer" data-field="x_signer" data-hidden="1" name="fsignergrid$x<?= $Grid->RowIndex ?>_signer" id="fsignergrid$x<?= $Grid->RowIndex ?>_signer" value="<?= HtmlEncode($Grid->signer->FormValue) ?>">
<input type="hidden" data-table="signer" data-field="x_signer" data-hidden="1" name="fsignergrid$o<?= $Grid->RowIndex ?>_signer" id="fsignergrid$o<?= $Grid->RowIndex ?>_signer" value="<?= HtmlEncode($Grid->signer->OldValue) ?>">
<?php } ?>
<?php } ?>
</td>
    <?php } ?>
    <?php if ($Grid->signed->Visible) { // signed ?>
        <td data-name="signed" <?= $Grid->signed->cellAttributes() ?>>
<?php if ($Grid->RowType == ROWTYPE_ADD) { // Add record ?>
<span id="el<?= $Grid->RowCount ?>_signer_signed" class="form-group">
<template id="tp_x<?= $Grid->RowIndex ?>_signed">
    <div class="custom-control custom-radio">
        <input type="radio" class="custom-control-input" data-table="signer" data-field="x_signed" name="x<?= $Grid->RowIndex ?>_signed" id="x<?= $Grid->RowIndex ?>_signed"<?= $Grid->signed->editAttributes() ?>>
        <label class="custom-control-label"></label>
    </div>
</template>
<div id="dsl_x<?= $Grid->RowIndex ?>_signed" class="ew-item-list"></div>
<input type="hidden"
    is="selection-list"
    id="x<?= $Grid->RowIndex ?>_signed"
    name="x<?= $Grid->RowIndex ?>_signed"
    value="<?= HtmlEncode($Grid->signed->CurrentValue) ?>"
    data-type="select-one"
    data-template="tp_x<?= $Grid->RowIndex ?>_signed"
    data-target="dsl_x<?= $Grid->RowIndex ?>_signed"
    data-repeatcolumn="5"
    class="form-control<?= $Grid->signed->isInvalidClass() ?>"
    data-table="signer"
    data-field="x_signed"
    data-value-separator="<?= $Grid->signed->displayValueSeparatorAttribute() ?>"
    <?= $Grid->signed->editAttributes() ?>>
<div class="invalid-feedback"><?= $Grid->signed->getErrorMessage() ?></div>
</span>
<input type="hidden" data-table="signer" data-field="x_signed" data-hidden="1" name="o<?= $Grid->RowIndex ?>_signed" id="o<?= $Grid->RowIndex ?>_signed" value="<?= HtmlEncode($Grid->signed->OldValue) ?>">
<?php } ?>
<?php if ($Grid->RowType == ROWTYPE_EDIT) { // Edit record ?>
<span id="el<?= $Grid->RowCount ?>_signer_signed" class="form-group">
<template id="tp_x<?= $Grid->RowIndex ?>_signed">
    <div class="custom-control custom-radio">
        <input type="radio" class="custom-control-input" data-table="signer" data-field="x_signed" name="x<?= $Grid->RowIndex ?>_signed" id="x<?= $Grid->RowIndex ?>_signed"<?= $Grid->signed->editAttributes() ?>>
        <label class="custom-control-label"></label>
    </div>
</template>
<div id="dsl_x<?= $Grid->RowIndex ?>_signed" class="ew-item-list"></div>
<input type="hidden"
    is="selection-list"
    id="x<?= $Grid->RowIndex ?>_signed"
    name="x<?= $Grid->RowIndex ?>_signed"
    value="<?= HtmlEncode($Grid->signed->CurrentValue) ?>"
    data-type="select-one"
    data-template="tp_x<?= $Grid->RowIndex ?>_signed"
    data-target="dsl_x<?= $Grid->RowIndex ?>_signed"
    data-repeatcolumn="5"
    class="form-control<?= $Grid->signed->isInvalidClass() ?>"
    data-table="signer"
    data-field="x_signed"
    data-value-separator="<?= $Grid->signed->displayValueSeparatorAttribute() ?>"
    <?= $Grid->signed->editAttributes() ?>>
<div class="invalid-feedback"><?= $Grid->signed->getErrorMessage() ?></div>
</span>
<?php } ?>
<?php if ($Grid->RowType == ROWTYPE_VIEW) { // View record ?>
<span id="el<?= $Grid->RowCount ?>_signer_signed">
<span<?= $Grid->signed->viewAttributes() ?>>
<?= $Grid->signed->getViewValue() ?></span>
</span>
<?php if ($Grid->isConfirm()) { ?>
<input type="hidden" data-table="signer" data-field="x_signed" data-hidden="1" name="fsignergrid$x<?= $Grid->RowIndex ?>_signed" id="fsignergrid$x<?= $Grid->RowIndex ?>_signed" value="<?= HtmlEncode($Grid->signed->FormValue) ?>">
<input type="hidden" data-table="signer" data-field="x_signed" data-hidden="1" name="fsignergrid$o<?= $Grid->RowIndex ?>_signed" id="fsignergrid$o<?= $Grid->RowIndex ?>_signed" value="<?= HtmlEncode($Grid->signed->OldValue) ?>">
<?php } ?>
<?php } ?>
</td>
    <?php } ?>
    <?php if ($Grid->created_at->Visible) { // created_at ?>
        <td data-name="created_at" <?= $Grid->created_at->cellAttributes() ?>>
<?php if ($Grid->RowType == ROWTYPE_ADD) { // Add record ?>
<span id="el<?= $Grid->RowCount ?>_signer_created_at" class="form-group">
<input type="<?= $Grid->created_at->getInputTextType() ?>" data-table="signer" data-field="x_created_at" name="x<?= $Grid->RowIndex ?>_created_at" id="x<?= $Grid->RowIndex ?>_created_at" maxlength="19" placeholder="<?= HtmlEncode($Grid->created_at->getPlaceHolder()) ?>" value="<?= $Grid->created_at->EditValue ?>"<?= $Grid->created_at->editAttributes() ?>>
<div class="invalid-feedback"><?= $Grid->created_at->getErrorMessage() ?></div>
<?php if (!$Grid->created_at->ReadOnly && !$Grid->created_at->Disabled && !isset($Grid->created_at->EditAttrs["readonly"]) && !isset($Grid->created_at->EditAttrs["disabled"])) { ?>
<script>
loadjs.ready(["fsignergrid", "datetimepicker"], function() {
    ew.createDateTimePicker("fsignergrid", "x<?= $Grid->RowIndex ?>_created_at", {"ignoreReadonly":true,"useCurrent":false,"format":0});
});
</script>
<?php } ?>
</span>
<input type="hidden" data-table="signer" data-field="x_created_at" data-hidden="1" name="o<?= $Grid->RowIndex ?>_created_at" id="o<?= $Grid->RowIndex ?>_created_at" value="<?= HtmlEncode($Grid->created_at->OldValue) ?>">
<?php } ?>
<?php if ($Grid->RowType == ROWTYPE_EDIT) { // Edit record ?>
<span id="el<?= $Grid->RowCount ?>_signer_created_at" class="form-group">
<input type="<?= $Grid->created_at->getInputTextType() ?>" data-table="signer" data-field="x_created_at" name="x<?= $Grid->RowIndex ?>_created_at" id="x<?= $Grid->RowIndex ?>_created_at" maxlength="19" placeholder="<?= HtmlEncode($Grid->created_at->getPlaceHolder()) ?>" value="<?= $Grid->created_at->EditValue ?>"<?= $Grid->created_at->editAttributes() ?>>
<div class="invalid-feedback"><?= $Grid->created_at->getErrorMessage() ?></div>
<?php if (!$Grid->created_at->ReadOnly && !$Grid->created_at->Disabled && !isset($Grid->created_at->EditAttrs["readonly"]) && !isset($Grid->created_at->EditAttrs["disabled"])) { ?>
<script>
loadjs.ready(["fsignergrid", "datetimepicker"], function() {
    ew.createDateTimePicker("fsignergrid", "x<?= $Grid->RowIndex ?>_created_at", {"ignoreReadonly":true,"useCurrent":false,"format":0});
});
</script>
<?php } ?>
</span>
<?php } ?>
<?php if ($Grid->RowType == ROWTYPE_VIEW) { // View record ?>
<span id="el<?= $Grid->RowCount ?>_signer_created_at">
<span<?= $Grid->created_at->viewAttributes() ?>>
<?= $Grid->created_at->getViewValue() ?></span>
</span>
<?php if ($Grid->isConfirm()) { ?>
<input type="hidden" data-table="signer" data-field="x_created_at" data-hidden="1" name="fsignergrid$x<?= $Grid->RowIndex ?>_created_at" id="fsignergrid$x<?= $Grid->RowIndex ?>_created_at" value="<?= HtmlEncode($Grid->created_at->FormValue) ?>">
<input type="hidden" data-table="signer" data-field="x_created_at" data-hidden="1" name="fsignergrid$o<?= $Grid->RowIndex ?>_created_at" id="fsignergrid$o<?= $Grid->RowIndex ?>_created_at" value="<?= HtmlEncode($Grid->created_at->OldValue) ?>">
<?php } ?>
<?php } ?>
</td>
    <?php } ?>
<?php
// Render list options (body, right)
$Grid->ListOptions->render("body", "right", $Grid->RowCount);
?>
    </tr>
<?php if ($Grid->RowType == ROWTYPE_ADD || $Grid->RowType == ROWTYPE_EDIT) { ?>
<script>
loadjs.ready(["fsignergrid","load"], function () {
    fsignergrid.updateLists(<?= $Grid->RowIndex ?>);
});
</script>
<?php } ?>
<?php
    }
    } // End delete row checking
    if (!$Grid->isGridAdd() || $Grid->CurrentMode == "copy")
        if (!$Grid->Recordset->EOF) {
            $Grid->Recordset->moveNext();
        }
}
?>
<?php
    if ($Grid->CurrentMode == "add" || $Grid->CurrentMode == "copy" || $Grid->CurrentMode == "edit") {
        $Grid->RowIndex = '$rowindex$';
        $Grid->loadRowValues();

        // Set row properties
        $Grid->resetAttributes();
        $Grid->RowAttrs->merge(["data-rowindex" => $Grid->RowIndex, "id" => "r0_signer", "data-rowtype" => ROWTYPE_ADD]);
        $Grid->RowAttrs->appendClass("ew-template");
        $Grid->RowType = ROWTYPE_ADD;

        // Render row
        $Grid->renderRow();

        // Render list options
        $Grid->renderListOptions();
        $Grid->StartRowCount = 0;
?>
    <tr <?= $Grid->rowAttributes() ?>>
<?php
// Render list options (body, left)
$Grid->ListOptions->render("body", "left", $Grid->RowIndex);
?>
    <?php if ($Grid->signer->Visible) { // signer ?>
        <td data-name="signer">
<?php if (!$Grid->isConfirm()) { ?>
<span id="el$rowindex$_signer_signer" class="form-group signer_signer">
    <select
        id="x<?= $Grid->RowIndex ?>_signer"
        name="x<?= $Grid->RowIndex ?>_signer"
        class="form-control ew-select<?= $Grid->signer->isInvalidClass() ?>"
        data-select2-id="signer_x<?= $Grid->RowIndex ?>_signer"
        data-table="signer"
        data-field="x_signer"
        data-value-separator="<?= $Grid->signer->displayValueSeparatorAttribute() ?>"
        data-placeholder="<?= HtmlEncode($Grid->signer->getPlaceHolder()) ?>"
        <?= $Grid->signer->editAttributes() ?>>
        <?= $Grid->signer->selectOptionListHtml("x{$Grid->RowIndex}_signer") ?>
    </select>
    <div class="invalid-feedback"><?= $Grid->signer->getErrorMessage() ?></div>
<?= $Grid->signer->Lookup->getParamTag($Grid, "p_x" . $Grid->RowIndex . "_signer") ?>
<script>
loadjs.ready("head", function() {
    var el = document.querySelector("select[data-select2-id='signer_x<?= $Grid->RowIndex ?>_signer']"),
        options = { name: "x<?= $Grid->RowIndex ?>_signer", selectId: "signer_x<?= $Grid->RowIndex ?>_signer", language: ew.LANGUAGE_ID, dir: ew.IS_RTL ? "rtl" : "ltr" };
    options.dropdownParent = $(el).closest("#ew-modal-dialog, #ew-add-opt-dialog")[0];
    Object.assign(options, ew.vars.tables.signer.fields.signer.selectOptions);
    ew.createSelect(options);
});
</script>
</span>
<?php } else { ?>
<span id="el$rowindex$_signer_signer" class="form-group signer_signer">
<span<?= $Grid->signer->viewAttributes() ?>>
<input type="text" readonly class="form-control-plaintext" value="<?= HtmlEncode(RemoveHtml($Grid->signer->getDisplayValue($Grid->signer->ViewValue))) ?>"></span>
</span>
<input type="hidden" data-table="signer" data-field="x_signer" data-hidden="1" name="x<?= $Grid->RowIndex ?>_signer" id="x<?= $Grid->RowIndex ?>_signer" value="<?= HtmlEncode($Grid->signer->FormValue) ?>">
<?php } ?>
<input type="hidden" data-table="signer" data-field="x_signer" data-hidden="1" name="o<?= $Grid->RowIndex ?>_signer" id="o<?= $Grid->RowIndex ?>_signer" value="<?= HtmlEncode($Grid->signer->OldValue) ?>">
</td>
    <?php } ?>
    <?php if ($Grid->signed->Visible) { // signed ?>
        <td data-name="signed">
<?php if (!$Grid->isConfirm()) { ?>
<span id="el$rowindex$_signer_signed" class="form-group signer_signed">
<template id="tp_x<?= $Grid->RowIndex ?>_signed">
    <div class="custom-control custom-radio">
        <input type="radio" class="custom-control-input" data-table="signer" data-field="x_signed" name="x<?= $Grid->RowIndex ?>_signed" id="x<?= $Grid->RowIndex ?>_signed"<?= $Grid->signed->editAttributes() ?>>
        <label class="custom-control-label"></label>
    </div>
</template>
<div id="dsl_x<?= $Grid->RowIndex ?>_signed" class="ew-item-list"></div>
<input type="hidden"
    is="selection-list"
    id="x<?= $Grid->RowIndex ?>_signed"
    name="x<?= $Grid->RowIndex ?>_signed"
    value="<?= HtmlEncode($Grid->signed->CurrentValue) ?>"
    data-type="select-one"
    data-template="tp_x<?= $Grid->RowIndex ?>_signed"
    data-target="dsl_x<?= $Grid->RowIndex ?>_signed"
    data-repeatcolumn="5"
    class="form-control<?= $Grid->signed->isInvalidClass() ?>"
    data-table="signer"
    data-field="x_signed"
    data-value-separator="<?= $Grid->signed->displayValueSeparatorAttribute() ?>"
    <?= $Grid->signed->editAttributes() ?>>
<div class="invalid-feedback"><?= $Grid->signed->getErrorMessage() ?></div>
</span>
<?php } else { ?>
<span id="el$rowindex$_signer_signed" class="form-group signer_signed">
<span<?= $Grid->signed->viewAttributes() ?>>
<input type="text" readonly class="form-control-plaintext" value="<?= HtmlEncode(RemoveHtml($Grid->signed->getDisplayValue($Grid->signed->ViewValue))) ?>"></span>
</span>
<input type="hidden" data-table="signer" data-field="x_signed" data-hidden="1" name="x<?= $Grid->RowIndex ?>_signed" id="x<?= $Grid->RowIndex ?>_signed" value="<?= HtmlEncode($Grid->signed->FormValue) ?>">
<?php } ?>
<input type="hidden" data-table="signer" data-field="x_signed" data-hidden="1" name="o<?= $Grid->RowIndex ?>_signed" id="o<?= $Grid->RowIndex ?>_signed" value="<?= HtmlEncode($Grid->signed->OldValue) ?>">
</td>
    <?php } ?>
    <?php if ($Grid->created_at->Visible) { // created_at ?>
        <td data-name="created_at">
<?php if (!$Grid->isConfirm()) { ?>
<span id="el$rowindex$_signer_created_at" class="form-group signer_created_at">
<input type="<?= $Grid->created_at->getInputTextType() ?>" data-table="signer" data-field="x_created_at" name="x<?= $Grid->RowIndex ?>_created_at" id="x<?= $Grid->RowIndex ?>_created_at" maxlength="19" placeholder="<?= HtmlEncode($Grid->created_at->getPlaceHolder()) ?>" value="<?= $Grid->created_at->EditValue ?>"<?= $Grid->created_at->editAttributes() ?>>
<div class="invalid-feedback"><?= $Grid->created_at->getErrorMessage() ?></div>
<?php if (!$Grid->created_at->ReadOnly && !$Grid->created_at->Disabled && !isset($Grid->created_at->EditAttrs["readonly"]) && !isset($Grid->created_at->EditAttrs["disabled"])) { ?>
<script>
loadjs.ready(["fsignergrid", "datetimepicker"], function() {
    ew.createDateTimePicker("fsignergrid", "x<?= $Grid->RowIndex ?>_created_at", {"ignoreReadonly":true,"useCurrent":false,"format":0});
});
</script>
<?php } ?>
</span>
<?php } else { ?>
<span id="el$rowindex$_signer_created_at" class="form-group signer_created_at">
<span<?= $Grid->created_at->viewAttributes() ?>>
<input type="text" readonly class="form-control-plaintext" value="<?= HtmlEncode(RemoveHtml($Grid->created_at->getDisplayValue($Grid->created_at->ViewValue))) ?>"></span>
</span>
<input type="hidden" data-table="signer" data-field="x_created_at" data-hidden="1" name="x<?= $Grid->RowIndex ?>_created_at" id="x<?= $Grid->RowIndex ?>_created_at" value="<?= HtmlEncode($Grid->created_at->FormValue) ?>">
<?php } ?>
<input type="hidden" data-table="signer" data-field="x_created_at" data-hidden="1" name="o<?= $Grid->RowIndex ?>_created_at" id="o<?= $Grid->RowIndex ?>_created_at" value="<?= HtmlEncode($Grid->created_at->OldValue) ?>">
</td>
    <?php } ?>
<?php
// Render list options (body, right)
$Grid->ListOptions->render("body", "right", $Grid->RowIndex);
?>
<script>
loadjs.ready(["fsignergrid","load"], function() {
    fsignergrid.updateLists(<?= $Grid->RowIndex ?>);
});
</script>
    </tr>
<?php
    }
?>
</tbody>
</table><!-- /.ew-table -->
</div><!-- /.ew-grid-middle-panel -->
<?php if ($Grid->CurrentMode == "add" || $Grid->CurrentMode == "copy") { ?>
<input type="hidden" name="<?= $Grid->FormKeyCountName ?>" id="<?= $Grid->FormKeyCountName ?>" value="<?= $Grid->KeyCount ?>">
<?= $Grid->MultiSelectKey ?>
<?php } ?>
<?php if ($Grid->CurrentMode == "edit") { ?>
<input type="hidden" name="<?= $Grid->FormKeyCountName ?>" id="<?= $Grid->FormKeyCountName ?>" value="<?= $Grid->KeyCount ?>">
<?= $Grid->MultiSelectKey ?>
<?php } ?>
<?php if ($Grid->CurrentMode == "") { ?>
<input type="hidden" name="action" id="action" value="">
<?php } ?>
<input type="hidden" name="detailpage" value="fsignergrid">
</div><!-- /.ew-list-form -->
<?php
// Close recordset
if ($Grid->Recordset) {
    $Grid->Recordset->close();
}
?>
<?php if ($Grid->ShowOtherOptions) { ?>
<div class="card-footer ew-grid-lower-panel">
<?php $Grid->OtherOptions->render("body", "bottom") ?>
</div>
<div class="clearfix"></div>
<?php } ?>
</div><!-- /.ew-grid -->
<?php } ?>
<?php if ($Grid->TotalRecords == 0 && !$Grid->CurrentAction) { // Show other options ?>
<div class="ew-list-other-options">
<?php $Grid->OtherOptions->render("body") ?>
</div>
<div class="clearfix"></div>
<?php } ?>
<?php if (!$Grid->isExport()) { ?>
<script>
// Field event handlers
loadjs.ready("head", function() {
    ew.addEventHandlers("signer");
});
</script>
<script>
loadjs.ready("load", function () {
    // Write your table-specific startup script here, no need to add script tags.
});
</script>
<?php } ?>
